{$APPTYPE CONSOLE}
{$O+,R+}

uses
  SysUtils, Math;

function Pad(s: String; i: Integer): String;
begin
  result := s;
  while Length(result) < i do
    result := result + ' ';
end;

procedure Swap(var a, b: Double);
var
  t: Double;
begin
  t := a;
  a := b;
  b := t;
end;

const
  RUNNING = 'Running';
  JURY = 'jury';
  CONSUMED = 'time consumed';
  MAXPROGS = 20;
  MAXPASSES = 10;

var
  s: String;
  prog: String;
  progs_cnt, prog_index: Integer;
  time: Double;
  progs: array[1..MAXPROGS] of String;
  times: array[1..MAXPROGS, 1..MAXPASSES] of Double;
  pass_cnt: array[1..MAXPROGS] of Integer;
  avg: array[1..MAXPROGS] of Double;
  i, j, k: Integer;

begin
  // Parse
  Reset(Input, ParamStr(1));
  progs_cnt := 0;
  prog_index := 0;
  while not SeekEof do begin
    ReadLn(s);
    s := Trim(s);
    if (Copy(s, 1, Length(RUNNING)) = RUNNING) and (Pos('"', s) > 0) and (Pos(jury, s) = 0) then begin
      s := Copy(s, Pos('"', s) + 1, Length(s) - Pos('"', s));
      prog := Copy(s, 1, Pos('"', s) - 1);
      prog_index := 0;
      for i := 1 to progs_cnt do
        if progs[i] = prog then begin
          prog_index := i;
          break;
        end;
      if prog_index = 0 then begin
        Inc(progs_cnt);
        prog_index := progs_cnt;
        progs[prog_index] := prog;
      end;
    end else if (Copy(s, 1, Length(CONSUMED)) = CONSUMED) and (Pos(':', s) > 0) then begin
      s := Trim(Copy(s, Pos(':', s) + 1, Length(s) - Pos(':', s)));
      s := Copy(s, 1, Pos(' ', s) - 1);
      Val(s, time, j);
      Assert(j = 0);
      Inc(pass_cnt[prog_index]);
      times[prog_index, pass_cnt[prog_index]] := time;
    end;
  end;

  // Sort times
  for i := 1 to progs_cnt do
    for j := 1 to pass_cnt[i] do
      for k := 1 to j - 1 do
        if times[i, k] > times[i, j] then
          Swap(times[i, k], times[i, j]);

  // Compute center average (w/o highest and lowest)
  for i := 1 to progs_cnt do begin
    if pass_cnt[i] > 2 then begin
      avg[i] := 0;
      for j := 2 to pass_cnt[i] - 1 do
        avg[i] := avg[i] + times[i, j];
      avg[i] := avg[i] / (pass_cnt[i] - 2);
     end else
       avg[i] := -1;
  end;

  // Write result
  Rewrite(Output, ParamStr(2));
  for i := 1 to progs_cnt do
    WriteLn(Pad(progs[i], 30), ' - ', pass_cnt[i], ' passes - ', avg[i]:0:2, ' sec center average');
end.
