#include "testlib.h"

int const MAX_LINES = 1000;
int const MAX_LEN = 120;

int main(int argc, char **argv) {
  registerValidation(argc, argv);
	int lines_count = 0;
  while (!inf.eof()) {
    std::string line = inf.readLine();
    
    ++lines_count;
    ensuref(lines_count <= MAX_LINES, "Too many lines");

    int len = (int)line.length();
    ensuref(len > 0, "There is empty line");
    ensuref(len <= MAX_LEN, "Too long line (length %d)", len);
    ensuref(line[0] != ' ', "There is leading space");
    ensuref(line[len - 1] != ' ', "There is trailing space");
    for (int i = 0; i < len; ++i) {
      char ch = line[i];
      ensuref(ch == ' ' || ch == '.' || ch == ',' || isalpha(ch), "Bad character '%c' (code %d)", ch, (int)ch);
    }
  }  
  inf.readEof();
}
