#include <cstdio>
#include <cstring>
#include <cassert>
#include <cctype>
#include <string>

using namespace std;

#define MAXL 120

string abbr (string ab, string wd) {
  return ab.length () == 1 ? wd : ab + " (" + wd + ")";
}

char buf[MAXL + 8];

int main () {
  assert (freopen ("abbreviation.in", "rt", stdin));
  assert (freopen ("abbreviation.out", "wt", stdout));
  while (fgets (buf, sizeof (buf), stdin)) {
    int l = strlen (buf);
    string curab = "", curout = "", curcc = "", curcw = "";
    char curl = 0;
    assert (l <= MAXL + 1 && l && buf[l - 1] == '\n' && l > 1 && buf[0] != ' ' && buf[l - 2] != ' ');
    int state = 0;
    for (int i = 0; i < l; i++) {
      assert ((buf[i] >= 'a' && buf[i] <= 'z') || (buf[i] >= 'A' && buf[i] <= 'Z') ||
              buf[i] == '.' || buf[i] == ',' || buf[i] == ' ' || (buf[i] == '\n' && i == l - 1));
      //printf ("%c %d\n", buf[i], state);
      switch (state) {
        case 0:
          if (isupper (buf[i])) state = 2, curl = buf[i], curab = "", curcw = buf[i], curcc = ""; else
          if (islower (buf[i])) state = 1, curout = curout + buf[i]; else
          curout = curout + buf[i];
          break;
        case 1:
          if (!isalpha (buf[i])) state = 0, curout = curout + buf[i]; else
          curout = curout + buf[i];
          break;
        case 2:
          if (isupper (buf[i]) || (!islower (buf[i]) && curcw.length () == 1)) state = isupper (buf[i]) ? 1 : 0, curout = curout + curcw + buf[i]; else
          if (buf[i] == ' ') state = 3, curcc = curcw, curcw = " ", curab = curl; else
          if (!islower (buf[i])) state = 0, curout = curout + curcw + buf[i]; else
          curcw = curcw + buf[i];
          break;
        case 3:
          if (isupper (buf[i])) state = 4, curl = buf[i], curcw = curcw + buf[i]; else
          curout = curout + abbr (curab, curcc) + curcw + buf[i], state = islower (buf[i]) ? 1 : 0;
          break;
        case 4:
          if (isupper (buf[i]) || (!islower (buf[i]) && curcw.length () == 2)) state = isupper (buf[i]) ? 1 : 0, curout = curout + abbr (curab, curcc) + curcw + buf[i]; else
          if (buf[i] == ' ') state = 3, curcc = curcc + curcw, curcw = " ", curab = curab + curl; else
          if (!islower (buf[i])) state = 0, curcc = curcc + curcw, curab = curab + curl, curout = curout + abbr (curab, curcc) + buf[i]; else
          curcw = curcw + buf[i];
          break;
      }
    }
    printf ("%s", curout.c_str());
  }
}
