#ifdef DBG1
  #define _GLIBCXX_DEBUG
#endif

#include <cstdio>
#include <cassert>
#include <cstring>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

#ifdef DBG1
    #define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
    #define eprintf(...)
#endif

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair <int, int> pii;

#define TASKNAME "abbreviation"

static char s[300];
static char t[300];

int cntWords = 0;
char *startWords, *endWords;
bool hasSpace = false;

void appendWord(char *start, char *end) {
  if (cntWords == 0) {
    startWords = start;
  }
  endWords = end;
  t[cntWords++] = start[0];
  hasSpace = false;
}

void flushWords() {
  if (cntWords) {
    if (cntWords > 1) {
      t[cntWords] = 0;
      printf("%s (", t);
    }
    while (startWords < endWords) {
      printf("%c", *startWords);
      ++startWords;
    }
    if (cntWords > 1) {
      printf(")");
    }
    if (hasSpace) {
      printf(" ");
    }
    cntWords = 0;
    hasSpace = false;
  }
}

int main() {
  freopen(TASKNAME ".in", "r", stdin);
  freopen(TASKNAME ".out", "w", stdout);

  while (gets(s)) {
    for (int i = 0; s[i]; ) {
      if (s[i] == ' ') {
        if (cntWords != 0 && !hasSpace) {
          hasSpace = true;
        } else {
          flushWords();
          printf(" ");
        }
        ++i;
      } else if (!isalpha(s[i])) {
        flushWords();
        printf("%c", s[i]);
        ++i;
      } else {
        char *start = s + i;
        bool good = ('A' <= s[i] && s[i] <= 'Z');
        ++i;
        while (isalpha(s[i])) {
          good &= ('a' <= s[i] && s[i] <= 'z');
          ++i;
        }
        good &= (start + 1 != s + i);
        if (good) {
          appendWord(start, s + i);
        } else {
          flushWords();
          while (start < s + i) {
            printf("%c", *start);
            start++;
          }
        }
      }
    }
    flushWords();
    printf("\n");
  }
  return 0;
}
