import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.StringTokenizer;
 
public class abbreviation_sm {
    boolean isCW(String s) {
        if (s.length() < 2) {
            return false;
        }
        if (!('A' <= s.charAt(0) && s.charAt(0) <= 'Z')) {
            return false;
        }
        for (int i = 1; i < s.length(); i++) {
            if (!('a' <= s.charAt(i) && s.charAt(i) <= 'z')) {
                return false;
            }
        }
        return true;
    }
 
    String proceed(String line) {
        ArrayList<String> tokens = new ArrayList<>();
        StringBuffer sb = new StringBuffer();
        for (char c : (line + "$").toCharArray()) {
            if (c == ' ' || c == '.' || c == ',' || c == '$') {
                if (sb.length() > 0) {
                    tokens.add(sb.toString());
                    sb = new StringBuffer();
                }
                tokens.add("" + c);
            } else {
                sb.append(c);
            }
        }
//        System.err.println(tokens);
        ArrayList<String> buffer = new ArrayList<>();
        StringBuilder result = new StringBuilder();
        for (String s : tokens) {
            if (isCW(s)) {
                buffer.add(s);
            } else if (s.equals(" ") && buffer.size() > 0 && !buffer.get(buffer.size() -1).equals(" ")) {
                buffer.add(s);
            } else {
                boolean endSpace = false;
                if (buffer.size() > 0 && buffer.get(buffer.size() - 1).equals(" ")) {
                    buffer.remove(buffer.size() - 1);
                    endSpace = true;
                }
                if (buffer.size() > 2) {
                    StringBuilder abbr = new StringBuilder();
                    for (String x : buffer) {
                        if (!x.equals(" ")) {
                            abbr.append(x.charAt(0));
                        }
                    }
                    result.append(abbr);
                    result.append(" (");
                }
                for (int i = 0; i < buffer.size(); i++) {
                    result.append(buffer.get(i));
                }
                if (buffer.size() > 2) {
                    result.append(")");
                }
                buffer.clear();
                if(endSpace) {
                    result.append(" ");
                }
                result.append(s);
            }
 
        }
        String s = result.toString();
        return s.substring(0, s.length() - 1);
    }
 
    void solve() throws IOException {
        while (true) {
            String s = br.readLine();
            if (s == null) break;
            out.println(proceed(s));
        }
    }
 
    BufferedReader br;
    PrintWriter out;
 
    void run() throws IOException {
        br = new BufferedReader(new FileReader("abbreviation.in"));
        out = new PrintWriter("abbreviation.out");
        solve();
        out.close();
    }
 
    public static void main(String[] args) throws IOException {
        new abbreviation_sm().run();
    }
}
