import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;

import java.util.Arrays;

import static java.lang.String.format;

/**
 * Created by Niyaz Nigmatullin on 18.11.16.
 */
public class Check implements Checker {

    private static void wa(String comment) {
        throw new Outcome(Outcome.Type.WA, comment);
    }

    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        int n = inf.nextInt();
        String jY = ans.nextToken();
        String pY = ouf.nextToken();
        if (!pY.equals("YES") && !pY.equals("NO")) {
            wa("YES or NO expected on the first line");
        }
        String[] words = new String[n];
        String[] inputWords = new String[n];
        for (int i = 0; i < n; i++) {
            inputWords[i] = inf.nextToken();
        }
        if (pY.equals("YES")) {
            for (int i = 0; i < n; i++) {
                words[i] = ouf.nextToken();
            }
            for (int i = 0; i < n; i++) {
                String iWord = inputWords[i];
                int length = iWord.length();
                String pWord = words[i];
                if (pWord.length() != length) {
                    wa(format("Word of length %d expected, but of length %d found at line %d",
                            length, pWord.length(), i + 1));
                }
                for (int j = 0; j < length; j++) {
                    if (pWord.charAt(j) != '0' && pWord.charAt(j) != '1') {
                        wa(format("Invalid character at position %d in line %d", j + 1, i + 1));
                    }
                    if (pWord.charAt(j) != iWord.charAt(j) && iWord.charAt(j) != '?') {
                        wa(format("Code word doesn't correspond to input code word at line %d", i + 1));
                    }
                }
            }
            Arrays.sort(words);
            for (int i = 0; i + 1 < n; i++) {
                if (words[i + 1].startsWith(words[i])) {
                    wa("Participant's code is not prefix code");
                }
            }
            if (jY.equals("NO")) {
                return new Outcome(Outcome.Type.FAIL, "Participant found solution");
            }
        } else {
            if (jY.equals("YES")) {
                wa("No solution found, but it exists");
            } else {
                return new Outcome(Outcome.Type.OK, "No solution");
            }
        }
        return new Outcome(Outcome.Type.OK, format("%d lines", n));
    }
}
