import java.io.*;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Random;

/**
 * Created by Niyaz Nigmatullin on 18.11.16.
 */
public class binary_nn_random {

    private static Random rng = new Random(58);

    private static void solve() throws IOException {
        int n = Integer.parseInt(br.readLine());
        Word[] words = new Word[n];
        for (int i = 0; i < n; i++) {
            words[i] = new Word(br.readLine(), i);
        }
        for (int i = 0; i < n; i++) {
            boolean has = false;
            for (char c : words[i].s) {
                if (c == '?') {
                    has = true;
                    break;
                }
            }
            if (has) continue;
            for (int j = 0; j < n; j++) {
                if (i == j) continue;
                if (startsWith(words[j].s, words[i].s)) {
                    out.println("NO");
                    return;
                }
            }
        }
        while (true) {
            boolean changed = false;
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < words[i].w.length; j++) {
                    if (words[i].w[j] != '?') continue;
                    int can = 0;
                    for (int k = 0; k < 2; k++) {
                        words[i].w[j] = (char) (k + '0');
                        boolean cant = false;
                        for (int e = 0; e < n; e++) {
                            if (i == e) continue;
                            if (startsWith(words[e].w, words[i].w) || startsWith(words[i].w, words[e].w)) {
                                cant = true;
                                break;
                            }
                        }
                        if (!cant) {
                            can |= 1 << k;
                        }
                    }
                    if (can == 0) {
                        out.println("NO");
                        return;
                    }
                    if (can == 3) {
                        words[i].w[j] = '?';
                        continue;
                    }
                    words[i].w[j] = (char) (Integer.numberOfTrailingZeros(can) + '0');
                    changed = true;
                }
            }
            if (!changed) break;
        }
        for (int i = 0; i < n; i++) {
            System.arraycopy(words[i].w, 0, words[i].s, 0, words[i].w.length);
        }
        while (true) {
            for (int i = 0; i < n; i++) {
                System.arraycopy(words[i].s, 0, words[i].w, 0, words[i].s.length);
            }
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < words[i].w.length; j++) {
                    if (words[i].w[j] == '?') {
                        words[i].w[j] = (char) (rng.nextInt(2) + '0');
                    }
                }
            }
            Arrays.sort(words, new Comparator<Word>() {
                @Override
                public int compare(Word o1, Word o2) {
                    return compareLex(o1.w, o2.w);
                }
            });
            boolean ok = true;
            for (int i = 0; i + 1 < n; i++) {
                if (startsWith(words[i + 1].w, words[i].w)) {
                    ok = false;
                    break;
                }
            }
            if (ok) break;
        }
        String[] ans = new String[n];
        for (Word e : words) {
            ans[e.id] = new String(e.w);
        }
        out.println("YES");
        for (String e : ans) {
            out.println(e);
        }
    }

    private static boolean startsWith(char[] s, char[] t) {
        if (s.length < t.length) return false;
        int i = 0;
        while (i < t.length && s[i] == t[i]) ++i;
        return i == t.length;
    }

    private static int compareLex(char[] s, char[] t) {
        int len = Math.min(s.length, t.length);
        int i = 0;
        while (i < len && s[i] == t[i]) ++i;
        if (i < len) {
            return Character.compare(s[i], t[i]);
        }
        return Integer.compare(s.length, t.length);
    }

    private static class Word {
        char[] s;
        int id;
        char[] w;

        public Word(String s, int id) {
            this.s = s.toCharArray();
            this.id = id;
            w = s.toCharArray();
        }
    }

    private static BufferedReader br;
    private static PrintWriter out;

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new FileReader("binary.in"));
        out = new PrintWriter("binary.out");
        solve();
        out.close();
        br.close();
    }
}
