#include <bits/stdc++.h>

using namespace std;

int const S = 2234567;
int const N = 555555;

vector<int> w[N];

int link[2][S];
int st[2 * N + S];
int color[2 * N];
int backColor[2 * N];
int was[2 * N];
int posQ[N];
int hadPair[N];
vector<int> edges[2 * N], rEdges[2 * N];
vector<int> entries[S];
int ans[N], ansComp[2 * N];
int cn;
int n;

int inv(int v) {
    return v < n ? v + n : v - n;
}

void makeOrder(int v) {
    was[v] = true;
    for (int to : edges[v]) {
        if (!was[to])
            makeOrder(to);
    }
    st[cn++] = v;
}

void makeColor(int v, int c) {
    color[v] = c;
    for (int to : rEdges[v]) {
        if (color[to] < 0) {
            makeColor(to, c);
        }
    }
}

bool solve2SAT() {
    int varsCount = n;
    int n = varsCount * 2;
    cn = 0;
    for (int i = 0; i < n; i++) was[i] = false;
    for (int i = 0; i < n; i++) {
        if (was[i]) continue;
        makeOrder(i);
    }
    int colors = 0;
    for (int i = 0; i < n; i++) color[i] = -1;
    for (int it = cn - 1; it >= 0; it--) {
        int v = st[it];
        if (color[v] < 0) {
            makeColor(v, colors);
            ++colors;
        }
    }
    for (int i = 0; i < varsCount; i++) {
        if (color[i] == color[inv(i)]) {
            return false;
        }
    }
    for (int i = 0; i < colors; i++) backColor[i] = -1;
    for (int i = 0; i < n; i++) {
        int c = color[i];
        int cc = color[inv(i)];
        assert(backColor[c] < 0 || backColor[c] == cc);
        backColor[c] = cc;
    }
    assert(~colors & 1);
    for (int i = 0; i < colors; i++) ansComp[i] = -1;
    for (int i = colors - 1; i >= 0; i--) {
        if (ansComp[i] < 0) {
            ansComp[i] = 1;
            ansComp[backColor[i]] = 0;
        }
    }
    for (int i = 0; i < varsCount; i++) {
        ans[i] = ansComp[color[i]] == 1;
    }
    return true;
}

void addClause(int v, int u) {
    v = (v < 0 ? ~v + n : v);
    u = (u < 0 ? ~u + n : u);
    edges[inv(v)].push_back(u);
    rEdges[u].push_back(inv(v));
    edges[inv(u)].push_back(v);
    rEdges[v].push_back(inv(u));
}

bool dfs(int v) {
    int oldCn = cn;
    for (int i : entries[v]) {
        for (int it = 0; it < cn; it++) {
            int j = st[it];
            if (i == j || ~i == j) continue;
            int ni = i < 0 ? ~i : i;
            int nj = j < 0 ? ~j : j;
            if (posQ[ni] >= 0 && posQ[nj] == posQ[ni]) {
                if ((hadPair[ni] >= 0 && hadPair[ni] != nj) || (hadPair[nj] >= 0 && hadPair[nj] != ni)) {
                    fprintf(stderr, "%d %d %d %d %d\n", ni, nj, hadPair[ni], hadPair[nj], n);
                    return false;
                }
                hadPair[ni] = nj;
                hadPair[nj] = ni;
            }
            addClause(~i, ~j);
        }
        st[cn++] = i;
    }
    if (link[0][v] >= 0)
        if (!dfs(link[0][v])) return false;
    if (link[1][v] >= 0)
        if (!dfs(link[1][v])) return false;
    cn = oldCn;
    return true;
}

int main() {
    assert(freopen("binary.in", "r", stdin));
    assert(freopen("binary.out", "w", stdout));
    assert(1 == scanf("%d", &n));
    for (int i = 0; i < n; i++) {
        int c = getchar();
        while (c <= 32) c = getchar();
        while (c > 32) {
            w[i].push_back(c == '?' ? -1 : (c == '0' ? 0 : 1));
            c = getchar();
        }
        int len = (int) w[i].size();
        posQ[i] = -1;
        hadPair[i] = -1;
        for (int j = 0; j < len; j++) {
            if (w[i][j] < 0) {
                posQ[i] = j;
                break;
            }
        }
    }
    int all = 1;
    for (int i = 0; i < n; i++) all += (int) w[i].size() * 2;
    for (int i = 0; i < all; i++) link[0][i] = link[1][i] = -1;
    int fr = 0;
    int root = fr++;
    for (int i = 0; i < n; i++) {
        for (int k = 0; k < 2; k++) {
            int v = root;
            for (int c : w[i]) {
                int letter = c < 0 ? k : c;
                int &to = link[letter][v];
                if (to < 0) {
                    to = fr++;
                }
                v = to;
            }
            entries[v].push_back(k == 0 ? i : ~i);
        }
    }
    cn = 0;
    if (!dfs(0) || !solve2SAT()) {
        puts("NO");
    } else {
        puts("YES");
        for (int i = 0; i < n; i++) {
            for (int j : w[i]) {
                if (j < 0) {
                    j = ans[i] ? 0 : 1;
                }
                putchar('0' + j);
            }
            puts("");
        }
    }
}
