import java.io.OutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.InputStream;
 
/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class binary_petr {
    public static void main(String[] args) {
        InputStream inputStream;
        try {
            inputStream = new FileInputStream("binary.in");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("binary.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        Binary solver = new Binary();
        solver.solve(1, in, out);
        out.close();
    }
 
    static class Binary {
        static final int MAX_TOTAL = (int) 2e6 + 2;
        static final int MAX_WORDS = (int) 5e5 + 2;
        static final int MAX_VERTICES = 2 * MAX_TOTAL + 2 * MAX_WORDS;
        static final int MAX_EDGES = 4 * MAX_TOTAL + 8 * MAX_WORDS;
        int[] by0;
        int[] by1;
        int[] parent;
        int[] depth;
        int total;
        Graph direct;
        Graph reverse;
        boolean[] used;
        int[] order;
        int[] comp;
        int[] firstMatching;
        int[] nextMatching;
        int orderPtr;
 
        void addEdge(int src, int dst) {
            innerAdd(src, dst);
            innerAdd(dst ^ 1, src ^ 1);
        }
 
        private void innerAdd(int src, int dst) {
            direct.add(src, dst);
            reverse.add(dst, src);
        }
 
        public void solve(int testNumber, InputReader in, PrintWriter out) {
            int n = in.nextInt();
            by0 = new int[MAX_TOTAL];
            by1 = new int[MAX_TOTAL];
            parent = new int[MAX_TOTAL];
            depth = new int[MAX_TOTAL];
            Arrays.fill(by0, -1);
            Arrays.fill(by1, -1);
            Arrays.fill(parent, -1);
            String[] originals = new String[n];
            int[] if0 = new int[n];
            int[] if1 = new int[n];
            firstMatching = new int[MAX_TOTAL];
            nextMatching = new int[2 * n];
            Arrays.fill(firstMatching, -1);
            Arrays.fill(nextMatching, -1);
            total = 1;
            direct = new Graph();
            reverse = new Graph();
            for (int i = 0; i < n; ++i) {
                String s = in.next();
                originals[i] = s;
                int qAt = s.indexOf('?');
                if (qAt < 0) {
                    if0[i] = -1;
                    if1[i] = -1;
                    int y = addToTrie(s);
                    addEdge(2 * i, 2 * i + 1);
                    addEdge(2 * i + 1, 2 * n + 2 * parent[y] + 1);
                    addEdge(2 * n + 2 * y + 1, 2 * i);
                    nextMatching[2 * i + 1] = firstMatching[y];
                    firstMatching[y] = 2 * i + 1;
                } else {
                    String s0 = s.substring(0, qAt) + "0" + s.substring(qAt + 1);
                    String s1 = s.substring(0, qAt) + "1" + s.substring(qAt + 1);
                    int y0 = addToTrie(s0);
                    int y1 = addToTrie(s1);
                    addEdge(2 * i, 2 * n + 2 * parent[y0] + 1);
                    addEdge(2 * i + 1, 2 * n + 2 * parent[y1] + 1);
                    addEdge(2 * n + 2 * y0 + 1, 2 * i + 1);
                    addEdge(2 * n + 2 * y1 + 1, 2 * i);
                    nextMatching[2 * i] = firstMatching[y0];
                    firstMatching[y0] = 2 * i;
                    nextMatching[2 * i + 1] = firstMatching[y1];
                    firstMatching[y1] = 2 * i + 1;
                }
            }
            for (int i = 0; i < total; ++i) {
                if (by0[i] >= 0) {
                    addEdge(2 * n + 2 * by0[i] + 1, 2 * n + 2 * i + 1);
                }
                if (by1[i] >= 0) {
                    addEdge(2 * n + 2 * by1[i] + 1, 2 * n + 2 * i + 1);
                }
                int u = firstMatching[i];
                int cnt = 0;
                while (u >= 0) {
                    ++cnt;
                    u = nextMatching[u];
                }
                if (cnt > 4 * depth[i]) {
                    out.println("NO");
                    return;
                }
                u = firstMatching[i];
                while (u >= 0) {
                    int v = firstMatching[i];
                    while (v >= 0) {
                        if (u != v) {
                            addEdge(u, v ^ 1);
                        }
                        v = nextMatching[v];
                    }
                    u = nextMatching[u];
                }
            }
            int v = 2 * total + 2 * n;
            order = new int[v];
            comp = new int[v];
            Arrays.fill(comp, -1);
            orderPtr = 0;
            used = new boolean[v];
            for (int i = 0; i < v; ++i)
                if (!used[i])
                    dfs1(i);
 
            for (int i = 0, j = 0; i < v; ++i) {
                int a = order[v - i - 1];
                if (comp[a] == -1)
                    dfs2(a, j++);
            }
 
            for (int i = 0; i < v; ++i)
                if (comp[i] == comp[i ^ 1]) {
                    out.println("NO");
                    return;
                }
            out.println("YES");
            for (int i = 0; i < n; ++i) {
                int ans = comp[2 * i + 1] > comp[2 * i] ? 1 : 0;
                String s = originals[i];
                int qAt = s.indexOf('?');
                if (qAt < 0) {
                    out.println(s);
                } else {
                    out.print(s.substring(0, qAt));
                    out.print(ans);
                    out.print(s.substring(qAt + 1));
                    out.println();
                }
            }
        }
 
        void dfs1(int v) {
            used[v] = true;
            for (int e = direct.firstOutgoing[v]; e >= 0; e = direct.next[e]) {
                int to = direct.dest[e];
                if (!used[to])
                    dfs1(to);
            }
            order[orderPtr++] = v;
        }
 
        void dfs2(int v, int cl) {
            comp[v] = cl;
            for (int e = reverse.firstOutgoing[v]; e >= 0; e = reverse.next[e]) {
                int to = reverse.dest[e];
                if (comp[to] == -1)
                    dfs2(to, cl);
            }
        }
 
        private int addToTrie(String s) {
            int at = 0;
            for (int i = 0; i < s.length(); ++i) {
                char ch = s.charAt(i);
                if (ch == '0') {
                    int d = by0[at];
                    if (d < 0) {
                        d = total++;
                        by0[at] = d;
                        parent[d] = at;
                        depth[d] = depth[at] + 1;
                    }
                    at = d;
                } else {
                    int d = by1[at];
                    if (d < 0) {
                        d = total++;
                        by1[at] = d;
                        parent[d] = at;
                        depth[d] = depth[at] + 1;
                    }
                    at = d;
                }
            }
            return at;
        }
 
        static class Graph {
            int[] dest = new int[MAX_EDGES];
            int[] firstOutgoing = new int[MAX_VERTICES];
            int[] next = new int[MAX_EDGES];
            int e = 0;
 
            public Graph() {
                Arrays.fill(firstOutgoing, -1);
            }
 
            public void add(int src, int dst) {
                dest[e] = dst;
                next[e] = firstOutgoing[src];
                firstOutgoing[src] = e;
                ++e;
            }
 
        }
 
    }
 
    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;
 
        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }
 
        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }
 
        public int nextInt() {
            return Integer.parseInt(next());
        }
 
    }
}
