import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Comparator;
import java.util.StringTokenizer;

/**
 * @author: pashka
 */
public class binary_pm implements Runnable {

    private int[][] trie;
    private int[] next;
    private int[] head;
    private DFS dfs1, dfs2;
    private int n;

    private void solve() throws IOException {
        n = nextInt();
        String[] s = new String[n];
        int sumLen = 1;
        for (int i = 0; i < n; i++) {
            s[i] = next();
            sumLen += s[i].length();
        }
        {
            String[] ss = s.clone();
            Arrays.sort(ss, new Comparator<String>() {
                @Override
                public int compare(String o1, String o2) {
                    return Integer.compare(o1.length(), o2.length());
                }
            });
            for (int i = 0; i < n; i++) {
                if (ss[i].length() > 30) break;
                if ((i + 1) > (1 << ss[i].length())) {
                    out.println("NO");
                    return;
                }
            }
        }
        trie = new int[2][2 * sumLen];
        next = new int[2 * n];
        head = new int[2 * sumLen];
        Arrays.fill(head, -1);
        for (int[] ints : trie) {
            Arrays.fill(ints, -1);
        }
        int m = 1;
        for (int i = 0; i < n; i++) {
            String template = s[i];
            for (char c = '0'; c <= '1'; c++) {
                String word = template.replace('?', c);
                if (template.indexOf('?') == -1 && c == '1') continue;
                int cur = 0;
                for (int j = 0; j < word.length(); j++) {
                    int cc = word.charAt(j) - '0';
                    if (trie[cc][cur] == -1) {
                        trie[cc][cur] = m++;
                    }
                    cur = trie[cc][cur];
                }
                next[2 * i + (c - '0')] = head[cur];
                head[cur] = 2 * i + (c - '0');
            }
        }
        dfs1 = new DFS();
        dfs1.init((5 * n + m) * 2, 6 * n + m);
        dfs2 = new DFS();
        dfs2.init((5 * n + m) * 2, 6 * n + m);
        nn = n + m;
        build(0);
        for (int i = 0; i < n; i++) {
            String template = s[i];
            if (template.indexOf('?') == -1) {
                addEdge(2 * i + 1, 2 * i);
            }
        }
        for (int i = 0; i < 2 * nn; i++) {
            dfs1.dfs(i);
        }
        int[] l = new int[2 * nn];
        int[] r = new int[2 * nn];
        int cc = 0;
        for (int i = 2 * nn - 1; i >= 0; i--) {
            int v = dfs1.p[i];
            if (!dfs2.z[v]) {
                l[cc] = dfs2.pn;
                dfs2.dfs(v);
                r[cc] = dfs2.pn;
                cc++;
            }
        }
        int[] c = new int[2 * nn];
        for (int i = 0; i < cc; i++) {
            for (int j = l[i]; j < r[i]; j++) {
                c[dfs2.p[j]] = i;
            }
        }
        for (int i = 0; i < nn; i++) {
            if (c[2 * i] == c[2 * i + 1]) {
                out.println("NO");
                return;
            }
        }
        boolean[] set = new boolean[cc];
        char[] res = new char[n];
        Arrays.fill(res, '!');
        for (int i = 0; i < 2 * nn; i++) {
            int v = c[dfs2.p[i]];
            if (!set[v]) {
                set[v] = true;
                set[c[dfs2.p[l[v]] ^ 1]] = true;
                for (int j = l[v]; j < r[v]; j++) {
                    int x = dfs2.p[j];
                    if (x < 2 * n) {
                        res[x / 2] = (char) ('0' + (1 - x % 2));
                    }
                }
            }
        }
        System.err.println(new String(res));
        out.println("YES");
        for (int i = 0; i < n; i++) {
            out.println(s[i].replace('?', res[i]));
        }
    }

    private void build(int node) {
        int prev = -1;
        for (int w = head[node]; w >= 0; w = next[w]) {
            if (prev != -1) {
                addEdge(2 * nn, 2 * prev);
                addEdge(w, 2 * prev);
            }
            addEdge(2 * nn, w ^ 1);
            prev = nn++;
        }
        int cur = n + node;
        for (int w = head[node]; w >= 0; w = next[w]) {
            addEdge(2 * cur, 2 * nn);
            addEdge(2 * cur, w ^ 1);
            addEdge(w, 2 * nn);
            cur = nn++;
        }
        for (int i = 0; i < 2; i++) {
            if (trie[i][node] >= 0) {
                addEdge(2 * cur, 2 * (n + trie[i][node]));
                build(trie[i][node]);
            }
        }
    }

    private void addEdge(int v, int u) {
        dfs1.addEdge(v, u);
        dfs1.addEdge(u ^ 1, v ^ 1);
        dfs2.addEdge(u, v);
        dfs2.addEdge(v ^ 1, u ^ 1);
    }

    int nn = 0;


    public class DFS {

        int[] p;
        int pn;

        void init(int n, int m) {
            this.n = n;
            this.m = m;
            last = 0;
            head = new int[n];
            nx = new int[m];
            dst = new int[m];
            Arrays.fill(head, -1);
            z = new boolean[n];
            p = new int[n];
        }

        void addEdge(int x, int y) {
            if (last == dst.length) {
                int newSize = dst.length * 2;
                int[] newDst = new int[newSize];
                System.arraycopy(dst, 0, newDst, 0, dst.length);
                dst = newDst;
                int[] newNx = new int[newSize];
                System.arraycopy(nx, 0, newNx, 0, nx.length);
                nx = newNx;
            }
            nx[last] = head[x];
            dst[last] = y;
            head[x] = last;
            last++;
        }

        private void dfs(int x) {
            if (z[x]) return;
            z[x] = true;
            int j = head[x];
            while (j >= 0) {
                int y = dst[j];
                dfs(y);
                j = nx[j];
            }
            p[pn++] = x;
        }

        int n, m;
        int[] head;
        int[] nx;
        int[] dst;
        boolean[] z;
        int last;
    }

    // -------------------------

    private BufferedReader br;
    private PrintWriter out;
    private StringTokenizer st;

    String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void main(String[] args) throws IOException {
        new Thread(null, new binary_pm(), "", 512 * 1024 * 1024).start();
    }

    public void run() {
        try {
            br = new BufferedReader(new FileReader("binary.in"));
            out = new PrintWriter("binary.out");
            solve();
            out.close();
        } catch (IOException e) {
            throw new RuntimeException();
        }
    }

}
