import java.io.OutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.io.InputStream;
 
/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class cactus_petr {
    public static void main(String[] args) {
        InputStream inputStream;
        try {
            inputStream = new FileInputStream("cactus.in");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("cactus.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        Cactus solver = new Cactus();
        solver.solve(1, in, out);
        out.close();
    }
 
    static class Cactus {
        ArrayList<String> res;
 
        void addEdge(Vertex a, Vertex b) {
            Edge ab = new Edge(a, b);
            Edge ba = new Edge(b, a);
            a.outgo.add(ab);
            b.outgo.add(ba);
            ab.rev = ba;
            ba.rev = ab;
        }
 
        public void solve(int testNumber, InputReader in, PrintWriter out) {
            int n = in.nextInt();
            int m = in.nextInt();
            Vertex[] vs = new Vertex[n];
            for (int i = 0; i < n; ++i) vs[i] = new Vertex(i + 1);
            for (int i = 0; i < m; ++i) {
                int k = in.nextInt();
                Vertex prev = vs[in.nextInt() - 1];
                for (int j = 1; j < k; ++j) {
                    Vertex cur = vs[in.nextInt() - 1];
                    addEdge(prev, cur);
                    prev = cur;
                }
            }
            findCycles(vs[0]);
            res = new ArrayList<>();
            doit(vs[0]);
            out.println(res.size());
            for (String x : res) out.println(x);
        }
 
        private void findCycles(Vertex root) {
            ArrayList<Edge> stack = new ArrayList<>();
            root.dfs(stack);
        }
 
        private void doit(Vertex root) {
            Cycle c = null;
            boolean any = false;
            for (Edge e : root.outgo) {
                if (e.exists) {
                    any = true;
                    if (e.cycle != null) {
                        c = e.cycle;
                        break;
                    }
                }
            }
            if (!any) return;
            if (c == null) {
                for (Edge e : root.outgo)
                    if (e.exists) {
                        e.exists = false;
                        e.rev.exists = false;
                        doit(e.dst);
                        res.add("r " + e.dst.index + " 1 3");
                        res.add("j " + root.index + " " + e.dst.index);
                        res.add("c " + root.index + " 1 3");
                        res.add("r " + root.index + " 3 2");
                    }
            } else {
                int offset = 0;
                while (c.edges.get(offset).src != root) ++offset;
                for (Edge e : c.edges) {
                    e.exists = e.rev.exists = false;
                }
                for (Edge e : c.edges) {
                    doit(e.src);
                }
                res.add("r " + root.index + " 1 4");
                for (int i = 0; i < c.edges.size() - 1; ++i) {
                    Vertex v1 = c.edges.get(offset + i).src;
                    Vertex v2 = c.edges.get(offset + i).dst;
                    res.add("r " + v2.index + " 1 3");
                    res.add("j " + root.index + " " + v2.index);
                    res.add("c " + root.index + " 4 3");
                    if (i == 0) {
                        res.add("r " + root.index + " 4 1");
                    } else {
                        res.add("r " + root.index + " 4 2");
                    }
                    res.add("r " + root.index + " 3 4");
                }
                res.add("c " + root.index + " 1 4");
                res.add("r " + root.index + " 4 2");
            }
        }
 
        static class Cycle {
            ArrayList<Edge> edges = new ArrayList<>();
 
        }
 
        static class Edge {
            Vertex src;
            Vertex dst;
            Edge rev;
            boolean exists = true;
            Cycle cycle;
 
            public Edge(Vertex src, Vertex dst) {
                this.src = src;
                this.dst = dst;
            }
 
        }
 
        static class Vertex {
            int index;
            int inStack = -1;
            ArrayList<Edge> outgo = new ArrayList<>();
 
            public Vertex(int index) {
                this.index = index;
            }
 
            public void dfs(ArrayList<Edge> stack) {
                inStack = stack.size();
                for (Edge e : outgo) {
                    if (inStack != stack.size()) throw new RuntimeException();
                    if (e.dst.inStack >= 0 && e.dst.inStack <= inStack - 2) {
                        Cycle c = new Cycle();
                        for (int i = e.dst.inStack; i < inStack; ++i) {
                            c.edges.add(stack.get(i));
                        }
                        c.edges.add(e);
                        for (Edge ee : c.edges) {
                            ee.cycle = ee.rev.cycle = c;
                        }
                    }
                    if (e.dst.inStack == -1) {
                        stack.add(e);
                        e.dst.dfs(stack);
                        stack.remove(stack.size() - 1);
                    }
                }
                inStack = -2;
            }
 
        }
 
    }
 
    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;
 
        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }
 
        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }
 
        public int nextInt() {
            return Integer.parseInt(next());
        }
 
    }
}