#!/usr/bin/python

from sys import argv

print 'prologues := 3; % make it work with ps2pdf'
print 'outputtemplate := "%j-%c.ps"; % better file names'
print ''
print 'u := 4mm;'
print 'beginfig(1);'
figid = 0
coords = open(argv[3]).read().splitlines()
coords = map(lambda x: map(int, x.split()), coords)
for i in range(len(coords)):
  print 'z%d = (%du,%du);' % (i, coords[i][0], coords[i][1])

shift = ''

def writeHeader():
  global figid, shift

  row = figid / 5
  col = figid % 5

  shiftx = col * 8
  shifty = row * 5
  
  shift = 'shifted (%du, -%du)' % (shiftx, shifty)
  
  figid += 1

def writeFooter(colors):

  for i in range(len(colors)):
    print 'pickup pencircle scaled 5pt;'
    print 'draw z%d %s withcolor black;' % (i, shift)#, ["black", "white", "(black + white)", "(green + blue)"][colors[i] - 1])
    print 'pickup pencircle scaled 3.5pt;'
    print 'draw z%d %s withcolor %s;' % (i, shift, ["black", "white", "(black + white) / 2", "(green + blue)"][colors[i] - 1])

  print '''
label.top("1", z0 %s);
label.top("2", z1 %s);
label.top("3", z2 %s);
label.top("4", z3 %s);
label.lrt("5", z4 %s);
label.llft("6", z5 %s);
label.top("7", z6 %s);
label.top("8", z7 %s);

''' % (shift, shift, shift, shift, shift, shift, shift, shift)

def writeMiddle(old_edges, new_edges, future_edges):
  print 'pickup pencircle scaled 1pt;'
  for i in old_edges:
    print 'draw z%d -- z%d withpen pencircle scaled 1pt %s;' % (i[0], i[1], shift)
  for i in new_edges:
    print 'draw z%d -- z%d withpen pencircle scaled 2pt %s;' % (i[0], i[1], shift)
  for i in future_edges: 
    print 'draw (z%d -- z%d) %s dashed evenly;' % (i[0], i[1], shift)
  

inp = open(argv[1]).read().splitlines()
n, k = map(int, inp[0].split())

es = []

for i in range(1, k + 1):
  data = map(int, inp[i].split())[1:]
  for i in range(1, len(data)):
    es.append([data[i-1] - 1, data[i] - 1])

colors = [1 for i in range(n)]
parts = [i for i in range(n)]

out = open(argv[2]).read().splitlines()[1:]

oes = []

for op in out:
  data = op.split()
  nes = []
  if data[0] == 'c':
    for i in range(n):
      if parts[i] == parts[int(data[1]) - 1] and colors[i] == int(data[2]):
        for j in range(n):
          if parts[j] == parts[int(data[1]) - 1] and colors[j] == int(data[3]):
            nes.append([i, j])
  elif data[0] == 'j':
    p1 = parts[int(data[1]) - 1]
    p2 = parts[int(data[2]) - 1]
    for i in range(n):
      if parts[i] == p1:
        parts[i] = p2
  elif data[0] == 'r':
    for i in range(n):
      if parts[i] == parts[int(data[1]) - 1] and colors[i] == int(data[2]):
        colors[i] = int(data[3])

  writeHeader()
  writeMiddle(oes, nes, filter(lambda x : x not in oes and x not in nes and parts[x[0]] == parts[x[1]], es))
  oes = oes + nes
  writeFooter(colors)

print 'endfig;'
print 'end;'
