import ru.ifmo.testlib.*;
import static ru.ifmo.testlib.Outcome.Type.*;

public class Check implements Checker {
	@Override
	public Outcome test(@SuppressWarnings("unused") InStream inf, InStream ouf, InStream ans) {
		long c = ouf.nextLong();
		String str = ouf.nextToken();
		int n = inf.nextInt();
		if (str.length() != n) {
			return new Outcome(WA, "The output string must have length n = " + n + ", but actual length is " + str.length());
		}
		for (int i = 0; i < n; i++) {
			if (str.charAt(i) != 'S' && str.charAt(i) != 'E') {
				return new Outcome(WA, "The output string must consist of characters 'S' and 'E'");
			}
		}

		int k = inf.nextInt();
		int minS = inf.nextInt();
		int minE = inf.nextInt();
		int[] s = new int[n];
		for (int i = 0; i < n; i++) {
			s[i] = inf.nextInt();
		}
		int[] e = new int[n];
		for (int i = 0; i < n; i++) {
			e[i] = inf.nextInt();
		}

		int lastE = 0;
		int lastS = 0;
		
		long delight = 0;
		for (int i = 0; i < n; i++) {
			if (str.charAt(i) == 'S') {
				delight += s[i];
				lastS++;
			} else {
				delight += e[i];
				lastE++;
			}
			if (i >= k - 1) {
				if (lastE < minE) {
					return new Outcome(WA, "Only " + lastE + " days eating from day " + (i - k + 2) + " to day " + (i + 1));
				}
				if (lastS < minS) {
					return new Outcome(WA, "Only " + lastS + " days sleeping from day " + (i - k + 2) + " to day " + (i + 1));
				}
				if (str.charAt(i - k + 1) == 'S') {
					lastS--;
				} else {
					lastE--;
				}
			}
		}
		if (c != delight) {
			return new Outcome(WA, "Declared delight = " + c + ", actual delight = " + delight);
		}

		long j = ans.nextLong();
		if (c < j) {
			return new Outcome(WA, "Not enough delight: expected " + j + ", found " + c);
		}
		if (c > j) {
			return new Outcome(FAIL, "Better than author's solution: expected " + j + ", found " + c);
		}

		return new Outcome(OK, "OK, delight = " + c);
	}
}
