import ru.ifmo.validate.*;

public class Validate implements Validator {
  private static final int MAX_N = 100_000;
  private static final int MAX_Q = 100_000;
  private static final int MAX_T = 1_000_000_000;
  private static final int MAX_K = 10_000;
  private static final int MAX_B = 1_000_000_000;

  @Override
  public void validate(ValidatingScanner in) {
    int n = in.nextInt(1, MAX_N);
    int q = in.nextInt(1, MAX_Q);
    in.eoln();
    int lastTime = 0;
    for (int i = 0; i < n; ++i) {
      String[] tokens = in.nextLine(0, 100).split(" ");
      assert tokens.length == 3 : "Expected 3 tokens";
      String operation = tokens[0];
      assert operation.equals("-") || operation.equals("+") : "Expected '+' or '-', found '" + operation + "'";
      int curTime = Integer.parseInt(tokens[1]);
      assert lastTime < curTime && curTime <= MAX_T : "Times are not increasing";
      int k = Integer.parseInt(tokens[2]);
      assert 1 <= k && k <= MAX_K : "Bad k_" + i;
      lastTime = curTime;
    }
    for (int i = 0; i < q; ++i) {
      in.nextInt(0, MAX_B);
    }
    in.eoln();
  }
}
