import java.io.OutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;
import java.io.BufferedReader;
import java.util.Comparator;
import java.util.Collections;
import java.io.InputStream;
 
/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class expect_petr {
    public static void main(String[] args) {
        InputStream inputStream;
        try {
            inputStream = new FileInputStream("expect.in");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("expect.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        Expect solver = new Expect();
        solver.solve(1, in, out);
        out.close();
    }
 
    static class Expect {
        public void solve(int testNumber, InputReader in, PrintWriter out) {
            int n = in.nextInt();
            int q = in.nextInt();
            int balance = 0;
            int prev = 0;
            List<Event> events = new ArrayList<>();
            for (int i = 0; i < n; ++i) {
                String w = in.next();
                int t = in.nextInt();
                int k = in.nextInt();
                if (w.equals("-")) k = -k;
                if (prev > 0) {
                    events.add(new Event(balance, t - prev));
                }
                prev = t;
                balance += k;
            }
            String[] res = new String[q];
            for (int i = 0; i < q; ++i) {
                int need = in.nextInt();
                if (need + balance < 0) {
                    res[i] = "INFINITY";
                } else {
                    events.add(new Event(-need, -(i + 1)));
                }
            }
            Collections.sort(events, new Comparator<Event>() {
 
                public int compare(Event o1, Event o2) {
                    return o1.atBalance - o2.atBalance;
                }
            });
            int startBalance = Integer.MIN_VALUE;
            int width = 0;
            long cur = 0;
            for (Event e : events) {
                if (width > 0)
                    cur += width * (long) (e.atBalance - startBalance);
                startBalance = e.atBalance;
                if (e.data >= 0) {
                    width += e.data;
                } else {
                    res[-e.data - 1] = cur + "";
                }
            }
            for (String x : res) {
                out.println(x);
            }
        }
 
        static class Event {
            int atBalance;
            int data;
 
            public Event(int atBalance, int data) {
                this.atBalance = atBalance;
                this.data = data;
            }
 
        }
 
    }
 
    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;
 
        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }
 
        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }
 
        public int nextInt() {
            return Integer.parseInt(next());
        }
 
    }
}