import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.StringTokenizer;

/**
 * Created by Aksenov239 on 18.11.2016.
 */
public class expect_va {
    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public class Query implements Comparable<Query> {
        int id;
        int y;

        public Query(int y, int id) {
            this.id = id;
            this.y = y;
        }

        public int compareTo(Query q) {
            return q.y - y;
        }
    }

    public class Event implements Comparable<Event> {
        int y;
        int width;

        public Event(int y, int width) {
            this.y = y;
            this.width = width;
        }

        public int compareTo(Event e) {
            return e.y - y;
        }

        public String toString () {
            return y + " " + width;
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        int q = nextInt();

        ArrayList<Event> events = new ArrayList<>();

        int currentLevel = 0;
        int prevT = 0;
        for (int i = 0; i < n; i++) {
            String type = nextToken();
            int time = nextInt();
            int x = nextInt();
            if ("+".equals(type)) {
                if (currentLevel >= 0) {
                    events.add(new Event(currentLevel, time - prevT));
                }
                currentLevel -= x;
            } else {
                if (currentLevel >= 0) {
                    events.add(new Event(currentLevel, time - prevT));
                }
                currentLevel += x;
            }
            prevT = time;
        }

        Collections.sort(events);

        Query[] queries = new Query[q];
        long[] ans = new long[q];
        for (int i = 0; i < q; i++) {
            queries[i] = new Query(nextInt(), i);
        }
        Arrays.sort(queries);

        long currentArea = 0;
        long currentWidth = 0;
        int currentQuery = 0;
        int prevY = 0;
        for (Event event : events) {
            while (currentQuery < queries.length && queries[currentQuery].y >= event.y) {
                ans[queries[currentQuery].id] = currentLevel > queries[currentQuery].y ? Long.MAX_VALUE :
                        currentArea + currentWidth * (prevY - queries[currentQuery].y);
                currentQuery++;
            }
            currentArea += currentWidth * (prevY - event.y);
            currentWidth += event.width;
            prevY = event.y;
        }
        for (int i = 0; i < q; i++) {
            out.println(ans[i] == Long.MAX_VALUE ? "INFINITY" : ans[i]);
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new FileReader(new File("expect.in")));
            out = new PrintWriter("expect.out");

            solve();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        new expect_va().run();
    }
}
