import java.io.*;
import java.util.StringTokenizer;

/**
 * Created by Aksenov239 on 18.11.2016.
 */
public class expect_va_tl {
    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public class Query {
        boolean type;
        int t, x;

        public Query(boolean type, int t, int x) {
            this.type = type;
            this.t = t;
            this.x = x;
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        int q = nextInt();

        Query[] queries = new Query[n];

        for (int i = 0; i < n; i++) {
            String type = nextToken();
            int time = nextInt();
            int x = nextInt();
            queries[i] = new Query(type.equals("+"), time, x);
        }

        int bestInf = 0;
        for (int i = 0; i < q; i++) {
            int start = nextInt();
            if (start < bestInf) {
                out.println("INFINITY");
                continue;
            }
            long currentLevel = -start;
            int prevT = 0;
            long ans = 0;
            for (int j = 0; j < n; j++) {
                ans += Math.max(currentLevel, 0) * (queries[j].t - prevT);
                if (queries[j].type) {
                    currentLevel -= queries[j].x;
                } else {
                    currentLevel += queries[j].x;
                }
                prevT = queries[j].t;
            }
            if (currentLevel > 0) {
                bestInf = Math.max(bestInf, start);
            }
            out.println(currentLevel <= 0 ? ans : "INFINITY");
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new FileReader(new File("expect.in")));
            out = new PrintWriter("expect.out");

            solve();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        new expect_va_tl().run();
    }
}
