import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;
import static ru.ifmo.testlib.Outcome.Type.*;

/**
 * Created by Niyaz Nigmatullin on 18.11.16.
 */
public class Check implements Checker {
    public Outcome outcome(Outcome.Type type, final String format, final Object... args) {
        return new Outcome(type, String.format(format, args));
    }

    public static final double EPS = 2e-9;

    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        double ja = ans.nextDouble();
        double pa = ouf.nextDouble();
        double error = Math.abs(ja - pa) / Math.max(1., Math.max(Math.abs(ja), Math.abs(pa)));
        if (error > EPS) {
            return outcome(WA, "Expected %.10f, found %.10f. error = %.10f", ja, pa, error);
        }
        return outcome(OK, "OK %.10f", pa);
    }

}
