import java.util.*;
import java.io.*;

public class foreign_av_monte_carlo {

	final int MAX_N = 5000;
	
	int getSum(int[] a, int from, int to) {
		return a[to + 1] - a[from];
	}
	
	void solve() {
		String s = in.nextToken();
		int[] c = new int[s.length()];
		for (int i = 0; i < c.length; i++) {
			c[i] = "CW".indexOf(s.charAt(i));
		}
		int[][] count = new int[2][c.length + 1];
		for (int i = 0; i < c.length; i++) {
			count[c[i]][i + 1]++;
			count[0][i + 1] += count[0][i];
			count[1][i + 1] += count[1][i];
		}
		int n = Math.min(MAX_N, c.length);
		double[] dp = new double[n + 1];
		dp[0] = 0;
		for (int i = 1; i <= n; i++) {
			double coef = 1.0 / i;
			int countWrong = 0;
			for (int j = i; j > 0; j--) {
				countWrong += c[n - j] != c[n - i] ? 1 : 0;
				dp[i] += coef * (countWrong + dp[j - 1]);
			}
		}
		
		int MAX = 1_000_000;
		Random rng = new Random(58);
		double result = 0;
		for (int IT = 0; IT < MAX; IT++) {
			int cur = c.length;
			while (cur > n) {
				int k = 1 + rng.nextInt(cur);
				result += getSum(count[1 - c[c.length - cur]], c.length - cur, c.length - (cur - k + 1));
				cur -= k;
			}
			result += dp[cur];
		}
		out.println(result / MAX);
	}

	FastScanner in;
	PrintWriter out;

	void run() {
		in = new FastScanner("foreign.in");
		try {
			out = new PrintWriter("foreign.out");
		} catch (FileNotFoundException e) {
		}
		solve();
		out.close();
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner() {
			br = new BufferedReader(new InputStreamReader(System.in));
		}

		public FastScanner(String s) {
			try {
				br = new BufferedReader(new FileReader(s));
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		public String nextToken() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
				}
			}
			return st.nextToken();
		}

		public int nextInt() {
			return Integer.parseInt(nextToken());
		}

		public long nextLong() {
			return Long.parseLong(nextToken());
		}

		public double nextDouble() {
			return Double.parseDouble(nextToken());
		}
	}

	public static void main(String[] args) {
		new foreign_av_monte_carlo().run();
	}
}
