#include <cassert>
#include <cstdio>
#include <cstring>

const int maxn = 1000010;

#define TASKNAME "foreign"

char s[maxn + 2];
long double sumC[maxn + 1], sumW[maxn + 1];
long double d[maxn + 1];

int main() {
  freopen(TASKNAME ".in", "r", stdin);
  freopen(TASKNAME ".out", "w", stdout);
  assert (fgets (s, maxn - 2, stdin));
  int n = strlen (s);
  if (n && s[n - 1] == '\n')
    n--;

  sumC[0] = sumW[0] = 0.0;
  for (int i = 0; i < n; i++) {
    sumC[i + 1] = sumC[i] + 1.0 * (s[n - 1 - i] == 'C') * (i + 1);
    sumW[i + 1] = sumW[i] + 1.0 * (s[n - 1 - i] == 'W') * (i + 1);
  }

  d[0] = 0.0;
  long double sum_d = 0.0;
  for (int i = 0; i < n; i++) {
    if (s[n - 1 - i] == 'C')
      d[i + 1] = (sumW[i + 1] + sum_d) / (i + 1);
    else
      d[i + 1] = (sumC[i + 1] + sum_d) / (i + 1);
    sum_d += d[i + 1];
  }
  printf ("%.20lf\n", (double)d[n]);
  return 0;
}

