import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;

import java.util.Objects;

import static ru.ifmo.testlib.Outcome.Type.OK;
import static ru.ifmo.testlib.Outcome.Type.WA;

public class Check implements Checker {

    private String getPlayerName(int id) {
        return id == 1 ? "Georgiy" : "Gennady";
    }

    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        for (int i = 0; i < 2; i++) {
            String user = ouf.nextToken();
            String jury = ans.nextToken();
            if (user.length() != jury.length()) {
                return new Outcome(WA, "Bad answer length for " + getPlayerName(i));
            }
            for (int j = 0; j < jury.length(); j++) {
                if (user.charAt(j) != jury.charAt(j)) {
                    return new Outcome(WA, "Answer for " + getPlayerName(i) +
                            " differs at position " + (j + 1) +
                            " expected: '" + jury.charAt(j) + "', found '" + user.charAt(j) + '"'
                    );
                }
            }
        }
        int n = inf.nextInt();
        int m = inf.nextInt();
        return new Outcome(OK, n + " vertices " + m + " arcs");
    }
}
