import ru.ifmo.validate.ValidatingScanner;
import ru.ifmo.validate.Validator;

import java.util.HashSet;

public class Validate implements Validator {

    private static final int MAX_N = 100000;
    private static final int MAX_M = 200000;

    private class Arc {
        int from, to;

        Arc(int from, int to) {
            this.from = from;
            this.to = to;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;

            Arc arc = (Arc) o;

            return from == arc.from && to == arc.to;

        }

        @Override
        public int hashCode() {
            int result = from;
            result = 31 * result + to;
            return result;
        }
    }

    @Override
    public void validate(ValidatingScanner in) throws Exception {
        int n = in.nextInt(1, MAX_N);
        int m = in.nextInt(1, MAX_M);
        in.eoln();

        HashSet<Arc> arcs = new HashSet<>();

        for (int i = 0; i < m; i++) {
            int a = in.nextInt(1, n);
            int b = in.nextInt(1, n);
            in.eoln();
            Arc arc = new Arc(a, b);
            assert !arcs.contains(arc) : "Duplicate arc " + a + " " + b;
            arcs.add(arc);
        }
        in.close();
    }

}
