import java.util.*;
import java.io.*;

public class game_av {

	List<Integer>[] graph;
	List<Integer>[] inEdges, outEdges;
	int[] outDegree;

	List<Integer>[] create(int len) {
		List<Integer>[] result = new List[len];
		for (int i = 0; i < len; i++) {
			result[i] = new ArrayList<>();
		}
		return result;
	}

	private void addEdge(int from, int to) {
		graph[from].add(to);
		inEdges[2 * to + 1].add(2 * from);
		inEdges[2 * to].add(2 * from + 1);
		outEdges[2 * from].add(2 * to + 1);
		outEdges[2 * from + 1].add(2 * to);
		outDegree[2 * from + 1]++;
		outDegree[2 * from]++;
	}

	void solve() {
		int n = in.nextInt(), m = in.nextInt();
		graph = create(n);
		inEdges = create(2 * n);
		outEdges = create(2 * n);
		outDegree = new int[2 * n];
		for (int i = 0; i < m; i++) {
			int from = in.nextInt() - 1, to = in.nextInt() - 1;
			addEdge(from, to);
		}

		boolean[] win = new boolean[2 * n];
		boolean[] lose = new boolean[2 * n];
		boolean[] visited = new boolean[2 * n];
		Queue<Integer> queue = new ArrayDeque<>();
		for (int i = 0; i < 2 * n; i++) {
			if (outDegree[i] == 0) {
				visited[i] = lose[i] = true;
				queue.add(i);
			}
		}
		while (!queue.isEmpty()) {
			int cur = queue.poll();
			for (int in : inEdges[cur]) {
				outDegree[in]--;
				if (visited[in]) {
					continue;
				}

				if (in % 2 == 1) {
					if (lose[cur]) {
						visited[in] = win[in] = true;
						queue.add(in);
					} else {
						if (outDegree[in] == 0) {
							visited[in] = lose[in] = true;
							queue.add(in);
						}
					}
				} else {
					if (outDegree[in] == 0) {
						boolean canWin = false;
						for (int v : outEdges[in]) {
							canWin |= lose[v];
						}
						if (canWin) {
							visited[in] = win[in] = true;
						} else {
							visited[in] = lose[in] = true;
						}
						queue.add(in);
					}
				}
			}
		}

		for (int i = 0; i < 2 * n; i++) {
			if (i % 2 == 1 && !visited[i]) {
				for (int j : outEdges[i]) {
					if (visited[j] && win[j]) {
						visited[i] = lose[i] = true;
						queue.add(i);
						break;
					}
				}
			}
		}

		while (!queue.isEmpty()) {
			int cur = queue.poll();
			for (int in : inEdges[cur]) {
				outDegree[in]--;
				if (visited[in]) {
					continue;
				}

				if (in % 2 == 1) {
					if (lose[cur]) {
						visited[in] = win[in] = true;
						queue.add(in);
					} else {
						visited[in] = lose[in] = true;
						queue.add(in);
					}
				} else {
					if (outDegree[in] == 0) {
						boolean canWin = false;
						for (int v : outEdges[in]) {
							canWin |= lose[v];
						}
						if (canWin) {
							visited[in] = win[in] = true;
						} else {
							visited[in] = lose[in] = true;
						}
						queue.add(in);
					}
				}
			}
		}

		for (int mod = 0; mod < 2; mod++) {
			for (int i = 0; i < n; i++) {
				if (win[2 * i + mod]) {
					out.print('W');
				} else if (lose[2 * i + mod]) {
					out.print('L');
				} else {
					out.print('D');
				}
			}
			out.println();
		}
	}

	FastScanner in;
	PrintWriter out;

	void run() {
		in = new FastScanner("game.in");
		try {
			out = new PrintWriter("game.out");
		} catch (FileNotFoundException e) {
		}
		solve();
		out.close();
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner() {
			br = new BufferedReader(new InputStreamReader(System.in));
		}

		public FastScanner(String s) {
			try {
				br = new BufferedReader(new FileReader(s));
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		public String nextToken() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
				}
			}
			return st.nextToken();
		}

		public int nextInt() {
			return Integer.parseInt(nextToken());
		}

		public long nextLong() {
			return Long.parseLong(nextToken());
		}

		public double nextDouble() {
			return Double.parseDouble(nextToken());
		}
	}

	public static void main(String[] args) {
		new game_av().run();
	}
}
