import java.io.*;
import java.util.*;
import java.util.function.Predicate;
import java.util.stream.Collectors;
import java.util.stream.IntStream;
import java.util.stream.Stream;

class game_gk {
    static Scanner in;
    static PrintWriter out;

    static class Solution {
        List<List<Integer>> from;
        List<List<Integer>> to;
        String[] result;
        int n;
        int[] outs;
        Queue<Integer> queue;

        void run() {
            n = in.nextInt();
            int m = in.nextInt();

            from = Stream.<List<Integer>>generate(ArrayList::new).limit(n * 2).collect(Collectors.toList());
            to = Stream.<List<Integer>>generate(ArrayList::new).limit(n * 2).collect(Collectors.toList());

            result = new String[n * 2];
            outs = new int[n * 2];
            Arrays.fill(result, "D");
            for (int i = 0; i < m; i++) {
                int u = in.nextInt() - 1;
                int v = in.nextInt() - 1;
                from.get(u).add(v + n);
                from.get(u + n).add(v);
                to.get(v + n).add(u);
                to.get(v).add(u + n);
                outs[u]++;
                outs[u + n]++;
            }

            queue = IntStream.range(0, 2 * n)
                    .filter(v -> from.get(v).isEmpty())
                    .boxed().collect(Collectors.toCollection(ArrayDeque::new));

            process("L"::equals);
            IntStream.range(n, 2 * n).forEach(v -> update(v, "W", "L", "D", q -> false));
            process(q -> true);

            out.println(String.join("", Arrays.copyOfRange(result, 0, n)));
            out.println(String.join("", Arrays.copyOfRange(result, n, n * 2)));
        }

        void process(Predicate<String> p) {
            while (!queue.isEmpty()) {
                update(queue.remove(), "L", "W", "L", p);
            }
        }

        void update(int v, String s, String t, String f, Predicate<String> p) {
            if (!"D".equals(result[v])) {
                return;
            }
            String r = from.get(v).stream().map(u -> result[u]).anyMatch(s::equals) ? t : f;
            if (r.equals(result[v])) {
                return;
            }
            result[v] = r;
            for (int u : to.get(v)) {
                if (--outs[u] == 0) {
                    queue.add(u);
                } else if (u >= n && p.test(result[v])) {
                    queue.add(u);
                }
            }
        }
    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("game.in"));
        out = new PrintWriter("game.out");

        new Solution().run();

        in.close();
        out.close();
    }

    static class Scanner {
        BufferedReader reader;
        StringTokenizer tokenizer = new StringTokenizer("");

        Scanner(File file) throws FileNotFoundException {
            reader = new BufferedReader(new FileReader(file));
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        String next() {
            while (!tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new AssertionError();
                }
            }
            return tokenizer.nextToken();
        }

        void close() {
        }
    }
}
