#include <cstdio>
#include <vector>
#include <string>
#include <queue>
#include <cassert>

using namespace std;

vector<vector<int>> g;
vector<vector<int>> gt;

vector<int> ts;
vector<bool> used;

void dfs(int v) {
  if (used[v]) return;
  used[v] = true;
  for (int u : g[v]) {
    dfs(u);
  }
  ts.push_back(v);
}


int main() {
  assert(freopen("game.in", "r", stdin));
  assert(freopen("game.out", "w", stdout));

  int n, m;
  assert(scanf("%d%d", &n, &m) == 2);
  g.resize(n);
  gt.resize(n);
  used.resize(n);
  for (int i = 0; i < m; i++) {
    int a, b;
    assert(scanf("%d%d", &a, &b) == 2);
    --a, --b;
    g[a].push_back(b);
    gt[b].push_back(a);
  }

  for (int i = 0; i < n; i++) {
    dfs(i);
  }

  string ans1(n, 'D');
  string ans2(n, 'D');

  for (int i = 0; i < n; i++) {
    if (g[i].size() == 0) {
      ans1[i] = ans2[i] = 'L';
    }
  }

  vector<bool> inq(n);

  queue<int> q;
  for (int i = 0; i < n; i++) {
    q.push(ts[i]);
    inq[ts[i]] = true;
  }


  int its = 0;

  while (!q.empty()) {
    int i = q.front();
    q.pop();
    inq[i] = false;
    bool haveL, haveW, haveD;
    char res;
    haveL = haveD = haveW = false;
    for (int u : g[i]) {
      ++its;
      if (ans2[u] == 'L') haveL = true;
      if (ans2[u] == 'D') haveD = true;
      if (ans2[u] == 'W') haveW = true;
    }
    if (haveD) res = 'D';
    else if (haveL) res = 'W';
    else res = 'L';
    int changed = false;
    if (res != ans1[i]) {
      ans1[i] = res;
      changed = true;
    }
      
    haveL = haveD = haveW = false;
    for (int u : g[i]) {
      ++its;
      if (ans1[u] == 'L') haveL = true;
      if (ans1[u] == 'D') haveD = true;
      if (ans1[u] == 'W') haveW = true;
    }
    if (haveL) res = 'W';
    else if (haveW || !haveD) res = 'L';
    else res = 'D';
    if (res != ans2[i]) {
      ans2[i] = res;
      changed = true;
    }

    if (changed) {
      for (int u: gt[i]) {
        if (!inq[u]) {
          inq[u] = true;
          q.push(u);
        }
      }
      //fprintf(stderr, "%s %s\n", ans1.c_str(), ans2.c_str());
    }
  }

  fprintf(stderr, "its = %d\n", its);


  printf("%s\n%s\n", ans1.c_str(), ans2.c_str());
  return 0;
}
