#include <cstdio>
#include <vector>
#include <string>
#include <queue>
#include <cassert>

using namespace std;

vector<vector<int>> g;
string ans;
int n;

char dfs(int v) {
  if (ans[v] == '?') return 'D';
  if (ans[v] != '.') return ans[v];
  ans[v] = '?';
  bool haveL = false, haveD = false, haveW = false;
  for (int u : g[v]) {
    char c = dfs(u);
    if (c == 'L') haveL = true;
    if (c == 'W') haveW = true;
    if (c == 'D') haveD = true;
  }
  if (v < n) {
    if (haveD) return ans[v] = 'D';
    if (haveL) return ans[v] = 'W';
    return ans[v] = 'L';
  }
  if (haveL) return ans[v] = 'W';
  if (haveW || !haveD) return ans[v] = 'L';
  return ans[v] = 'D';
}

int main() {
  assert(freopen("game.in", "r", stdin));
  assert(freopen("game.out", "w", stdout));

  int m;
  assert(scanf("%d%d", &n, &m) == 2);
  g.resize(2 * n);
  for (int i = 0; i < m; i++) {
    int a, b;
    assert(scanf("%d%d", &a, &b) == 2);
    --a, --b;
    g[a].push_back(b + n);
    g[a + n].push_back(b);
  }

  ans = string(2 * n, '.');

  for (int i = 0; i < n; i++) {
    dfs(2*i);
    dfs(2*i + 1);
  }

  printf("%s\n%s\n", ans.substr(0, n).c_str(), ans.substr(n).c_str());

  return 0;
}
