#include <cstdio>
#include <cassert>
#include <algorithm>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define sz(a) (int)(a).size()

inline int readChar();
template <class T = int> inline T readInt(); 
template <class T> inline void writeInt( T x, char end = 0 );
inline void writeChar( int x ); 
inline void writeWord( const char *s );

const int N = 1e6 + 10;
enum { LOSE = 1, WIN = 2 };

int res[N], cnt[N], cnt2[N];
vector<int> c[N], rc[N];
bool is_lose2[N], is_win2[N];

void lose( int v );
void win( int v ) {
	if (res[v]) return;
	res[v] = WIN;
	for (int x : rc[v])
		if (++cnt[x] == sz(c[x]))
			lose(x);

}
void lose( int v ) {
	if (res[v]) return;
	res[v] = LOSE;
	for (int x : rc[v]) win(x);
}

void lose2( int v );
void win2( int v ) {
	if (is_win2[v]) return;
	is_win2[v] = 1;
	for (int x : rc[v]) 
		if (++cnt2[x] == sz(c[x]))
			lose2(x);
}
void lose2( int v ) {
	if (is_lose2[v]) return;
	is_lose2[v] = 1;
	for (int x : rc[v]) win2(x);
}

int main() {
	assert(freopen("game.in", "r", stdin));
	assert(freopen("game.out", "w", stdout));

	int n = readInt();
	int m = readInt();
	while (m--) {
		int a = readInt() - 1;
		int b = readInt() - 1;
		c[a].push_back(b);
		rc[b].push_back(a);
	}
	forn(i, n)
		if (!c[i].size()) {
			lose(i);
			lose2(i);
			win2(i);
		}
	forn(i, n) {
		if (res[i] == LOSE) putchar('L');
		else if (is_lose2[i]) putchar('W');
		else putchar('D');
	}
	puts("");
	forn(i, n) {
		if (res[i] == WIN) putchar('W');
		else if (is_win2[i]) putchar('L');
		else putchar('D');
	}
	puts("");

}

static const int buf_size = 4096;

inline int getChar() {
	static char buf[buf_size];
	static int len = 0, pos = 0;
	if (pos == len)
		pos = 0, len = fread(buf, 1, buf_size, stdin);
	if (pos == len)
		return -1;
	return buf[pos++];
}

inline int readChar() {
	int c = getChar();
	while (c <= 32)
		c = getChar();
	return c;
}

template <class T>
inline T readInt() {
	int s = 1, c = readChar();
	T x = 0;
	if (c == '-')
		s = -1, c = getChar();
	while ('0' <= c && c <= '9')
		x = x * 10 + c - '0', c = getChar();
	return s == 1 ? x : -x;
}

/** Write */

static int write_pos = 0;
static char write_buf[buf_size];

inline void writeChar( int x ) {
	if (write_pos == buf_size)
		fwrite(write_buf, 1, buf_size, stdout), write_pos = 0;
	write_buf[write_pos++] = x;
}

template <class T> 
inline void writeInt( T x, char end ) {
	if (x < 0)
		writeChar('-'), x = -x;

	char s[24];
	int n = 0;
	while (x || !n)
		s[n++] = '0' + x % 10, x /= 10;
	while (n--)
		writeChar(s[n]);
	if (end)
		writeChar(end);
}

inline void writeWord( const char *s ) {
	while (*s)
		writeChar(*s++);
}

struct Flusher {
	~Flusher() {
		if (write_pos)
			fwrite(write_buf, 1, write_pos, stdout), write_pos = 0;
	}
} flusher;
