import ru.ifmo.validate.ValidatingScanner;
import ru.ifmo.validate.Validator;

import java.util.Arrays;
import java.util.stream.Collectors;

public class Validate implements Validator {
    private final static int MAX = 1 << 15;

    @Override
    public void validate(ValidatingScanner in) throws Exception {
        int lines_count = 0;
        while (true) {
            ++lines_count;
            assert lines_count <= 1000 : "Too many lines";
            final String[] parts = in.nextLine(0, 1000).split(" ");
            assert parts.length == 3 || parts.length == 4 || parts.length == 7 || parts.length == 8 : "Invalid format";
            if (parts.length % 2 == 0) {
                expect(parts[parts.length - 1], "||");
            }
            expect(parts[0], "x");
            expect(parts[1], ">=", "<=");
            int a = Integer.parseInt(parts[2]);
            assert -MAX <= a && a < MAX : "First number out of range";
            if (parts.length > 6) {
                expect(parts[1], ">=");
                expect(parts[3], "&&");
                expect(parts[4], "x");
                expect(parts[5], "<=");
                int b = Integer.parseInt(parts[6]);
                assert -MAX <= b && b < MAX : "Second number out of range";
            }
            if (parts.length % 2 == 1) {
                break;
            }
        }
    	  in.close();
    }

    private void expect(final String actual, final String... expected) {
        assert Arrays.asList(expected).indexOf(actual) >= 0 : String.format(
                "Expected %s, found '%s'",
                Arrays.stream(expected).map(s -> "'" + s + "'").collect(Collectors.joining(" or ")),
                actual
        );
    }
}
