#include <cstdio>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

typedef long long ll;

char s[2000];

const ll MIN = -(1LL << 31);
const ll MAX = (1LL << 31) - 1;

int main() {
  assert(freopen("hard.in", "r", stdin));
  assert(freopen("hard.out", "w", stdout));

  vector<pair<ll, int>> events;

  while (scanf(" %[^\r\n]", s) == 1) {
    ll l, r;
    if (sscanf(s, "x <= %lld", &r) == 1) {
      l = MIN;
    } else if (sscanf(s, "x >= %lld && x <= %lld", &l, &r) == 1) {
      r = MAX;
    }
    if (l <= r) {
      events.push_back(make_pair(l, 0));
      events.push_back(make_pair(r + 1LL, 1));
    }
  } 
  sort(events.begin(), events.end());

  int bal = 0;
  ll l = MIN;
  bool any = false;

  for (const auto &x : events) {
    if (x.second == 0) {
      bal++;
      if (bal == 1) {
        l = x.first;
      }
    } else {
      bal--;
      if (bal == 0) {
        if (any) {
          printf(" ||\n");
        }
        any = true;
        if (l == MIN && x.first - 1 == MAX) {
          printf("true");
        } else if (l == MIN) {
          printf("x <= %lld", x.first - 1);
        } else if (x.first - 1 == MAX) { 
          printf("x >= %lld", l);
        } else {
          printf("x >= %lld && x <= %lld", l, x.first - 1);
        }
      }
    }
  }
  
  if (!any) {
    printf("false");
  }
  printf("\n");
  return 0;
}
