#include <cstdio>
#include <cassert>
#include <vector>
#include <cstring>

using namespace std;

enum position {NEW, LEFT, RIGHT, TARGET};

position go(const char* s) {
  if (s) {
//    fprintf(stderr, "send request |%s|\n", s);
    printf("%s\n", s);
    fflush(stdout);
  }
  static char buf[200];
  assert(scanf("%s", buf) == 1);
  //fprintf(stderr, "got response |%s|\n", buf);
  if (!strcmp(buf, "center")) return NEW;
  if (!strcmp(buf, "left")) return LEFT;
  if (!strcmp(buf, "right")) return RIGHT;
  if (!strcmp(buf, "treasure")) return TARGET;
  assert(0);
}

int go_until(position u, position to) {
  int res = 0;
  while (true) {
    res++;
    position pos;
    if (to == LEFT) {
      pos = go("0 left 0");
    } else {
      pos = go("0 right 0");
    }
    if (pos == u) {
      return res;
    }
  }
}

void go_cnt(int cnt, position to) {
  for (int i = 0; i < cnt; i++) {
    if (to == LEFT) {
      go("0 left 0");
    } else {
      go("0 right 0");
    }
  }
}

int main() {
  int n;
  assert(scanf("%d", &n) == 1);
  if (n == 1) {
    while (go("0 left 0") != TARGET){};
    return 0;
  }
  vector<int> moves;
  vector<int> best;
  vector<int> bestl;
  moves.push_back(0);
  best.push_back(-1);
  bestl.push_back(0);

  assert(go(0) == NEW);

  do {
    /*
    for (int i = 0; i < (int)moves.size(); i++) {
      fprintf(stderr, "%d,%d,%d ", moves[i], best[i], bestl[i]);
    }
    fprintf(stderr, "\n");
    */
    position pos;
    if (moves.back() == n + 1 || (moves.back() == n && best.back() == n)) {
      pos = RIGHT;
      moves.pop_back();
      int l = bestl.back() - 1;
      bestl.pop_back();
      best.pop_back();
      assert(!moves.empty());
      if (best.back() == -1 || bestl.back() < l) {
        bestl.back() = l;
        best.back() = moves.back();
      }
    } else if (moves.back() == n) {
      assert(best.back() != -1);
      assert(bestl.back() > 0);
      moves.back()++;
      char buf[100];
      sprintf(buf, "%d left %d\n", best.back(), best.back());
      pos = go(buf);
      assert(pos != NEW && pos != TARGET);
    } else {
      moves.back()++;
      pos = go("1 left 1");
    }
    if (pos == NEW) {
      moves.push_back(0);
      best.push_back(-1);
      bestl.push_back(0);
      continue;
    }
    if (pos == TARGET) {
      break;
    }
    if (pos == RIGHT) {
      int cnt1 = go_until(LEFT, RIGHT);
      int cnt2 = go_until(RIGHT, LEFT);
      assert(cnt2 > 0);
      go_cnt(cnt1, RIGHT);
      go_cnt(cnt2 - 1, LEFT);
      if (best.back() == -1 || bestl.back() < cnt2) {
        bestl.back() = cnt2;
        best.back() = moves.back();
      }
      continue;
    }
    int cnt = go_until(RIGHT, RIGHT);
    go_cnt(cnt, LEFT);
    go_cnt(cnt - 1, LEFT);
    if (best.back() == -1 || bestl.back() < cnt) {
      bestl.back() = cnt;
      best.back() = moves.back();
    }
  } while (true);

}
