import java.io.*;
import java.util.*;

public class jenga_gk {
    private static Scanner in;
    private static PrintWriter out;

    static class Level {
        boolean cross;
        long c, sumX;
        int minI, maxI, minX, maxX;
        int n;
        Set<Integer> removed = new HashSet<>();

        public Level(final boolean cross, int n) {
            this.cross = cross;
            c = n;
            minI = 0;
            maxI = n - 1;
            this.sumX = n * (long) n;
            this.n = n;
            minX = cross ? n : minI * 2;
            maxX = cross ? n : maxI * 2 + 2;
        }

        public void remove(final int k) {
            c--;
            if (cross) {
                sumX -= n;
            } else {
                sumX -= 2 * k + 1;
            }
            removed.add(k);
            while (removed.contains(minI) && minI < n - 1) minI++;
            while (removed.contains(maxI) && maxI > 0) maxI--;
            minX = cross ? n : minI * 2;
            maxX = cross ? n : maxI * 2 + 2;
        }
    }

    private static class Solution {
        void run() {
            int n = in.nextInt();
            int w = in.nextInt();
            int h = in.nextInt();
            int m = in.nextInt();

            List<Level> xLevels = new ArrayList<>();
            List<Level> yLevels = new ArrayList<>();
            for (int i = h - 1; i >= 0; i--) {
                xLevels.add(new Level(i % 2 != 0, n));
                yLevels.add(new Level(i % 2 == 0, n));
            }

            for (int i = 0; i < m; i++) {
                int l = in.nextInt() - 1;
                int k = in.nextInt() - 1;
                xLevels.get(h - l - 1).remove(k);
                yLevels.get(h - l - 1).remove(k);
                if (collapses(xLevels) || collapses(yLevels)) {
                    out.println("yes");
                    out.println(i + 1);
                    return;
                }
            }
            out.println("no");
        }

        private boolean collapses(final List<Level> levels) {
            long c = 0;
            long sx = 0;
            for (Level level : levels) {
                if (c > 0 && !level.cross && (sx <= level.minX * c || level.maxX * c <= sx)) {
                    return true;
                }
                c += level.c;
                sx += level.sumX;
            }
            return false;
        }
    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("jenga.in"));
        out = new PrintWriter("jenga.out");

        new Solution().run();

        in.close();
        out.close();
    }

    static class Scanner {
        final BufferedReader reader;
        StringTokenizer tokenizer = new StringTokenizer("");

        Scanner(File file) throws FileNotFoundException {
            reader = new BufferedReader(new FileReader(file));
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        String next() {
            while (!tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new AssertionError();
                }
            }
            return tokenizer.nextToken();
        }

        void close() {
        }
    }
}
