import java.io.*;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.List;
import java.util.StringTokenizer;

public class jenga_gk_ok_bitset {
    private static Scanner in;
    private static PrintWriter out;

    static class Level {
        boolean cross;
        long c, sumX;
        int minI, maxI;
        int n;
        BitSet removed;

        public Level(final boolean cross, int n) {
            this.cross = cross;
            c = n;
            minI = 0;
            maxI = n - 1;
            this.sumX = n * (long) n;
            this.n = n;
        }

        public void remove(final int k) {
            c--;
            if (cross) {
                sumX -= n;
            } else {
                sumX -= 2 * k + 1;
            }
            if (removed == null) {
                removed = new BitSet(n);
            }
            removed.set(k);
            while (removed.get(minI) && minI < n - 1) minI++;
            while (removed.get(maxI) && maxI > 0) maxI--;
        }

        private int minX() {
            return cross ? n : minI * 2;
        }

        private int maxX() {
            return cross ? n : maxI * 2 + 2;
        }

        public long c() {
            return c;
        }

        public long sumX() {
            return sumX;
        }
    }

    private static class Solution {
        void run() {
            int n = in.nextInt();
            int w = in.nextInt();
            int h = in.nextInt();
            int m = in.nextInt();

            List<Level> xLevels = new ArrayList<>();
            List<Level> yLevels = new ArrayList<>();
            for (int i = 0; i < h; i++) {
                xLevels.add(new Level(i % 2 != 0, n));
                yLevels.add(new Level(i % 2 == 0, n));
            }

            for (int i = 0; i < m; i++) {
                int l = in.nextInt() - 1;
                int k = in.nextInt() - 1;
                xLevels.get(l).remove(k);
                yLevels.get(l).remove(k);
                if (collapses(xLevels) || collapses(yLevels)) {
                    out.println("yes");
                    out.println(i + 1);
                    return;
                }
            }
            out.println("no");
        }

        private boolean collapses(final List<Level> levels) {
            long c = 0;
            long sx = 0;
            for (int i = levels.size() - 1; i >= 0; i--) {
                Level level = levels.get(i);
                int minX = level.minX();
                int maxX = level.maxX();
                if (c > 0 && !level.cross && (sx <= minX * c || maxX * c <= sx)) {
                    return true;
                }
                c += levels.get(i).c();
                sx += levels.get(i).sumX();
            }
            return false;
        }

    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("jenga.in"));
        out = new PrintWriter("jenga.out");

        new Solution().run();

        in.close();
        out.close();
    }

    static class Scanner {
        final BufferedReader reader;
        StringTokenizer tokenizer = new StringTokenizer("");

        Scanner(File file) throws FileNotFoundException {
            reader = new BufferedReader(new FileReader(file));
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        String next() {
            while (!tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new AssertionError();
                }
            }
            return tokenizer.nextToken();
        }

        void close() {
        }
    }
}
