import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.stream.IntStream;

public class jenga_gk_tl_hm_hn {
    private static Scanner in;
    private static PrintWriter out;

    static class Level {
        boolean cross;
        int[] x;
        int c, sumX;
        int minI, maxI;

        public Level(final boolean cross, final int[] x) {
            this.cross = cross;
            this.x = x;
            c = x.length;
            minI = 0;
            maxI = c - 1;
            sumX = IntStream.of(x).sum();
        }

        public void remove(final int k) {
            c--;
            sumX -= x[k];
            x[k] = 0;
            while (x[minI] == 0 && minI < x.length - 1) minI++;
            while (x[maxI] == 0 && maxI > 0) maxI--;
        }

        private int minX() {
            return x[minI] - 1;
        }

        private int maxX() {
            return x[maxI] + 1;
        }

        public int c() {
            return c;
        }

        public int sumX() {
            return sumX;
        }
    }

    private static class Solution {
        void run() {
            int n = in.nextInt();
            int w = in.nextInt();
            int h = in.nextInt();
            int m = in.nextInt();

            List<Level> xLevels = new ArrayList<>();
            List<Level> yLevels = new ArrayList<>();
            for (int i = 0; i < h; i++) {
                Level along = new Level(false, IntStream.range(0, n).map(j -> j * 2 + 1).toArray());
                Level cross = new Level(true, IntStream.range(0, n).map(j -> n).toArray());
                xLevels.add(i % 2 == 0 ? along : cross);
                yLevels.add(i % 2 == 0 ? cross : along);
            }

            for (int i = 0; i < m; i++) {
                int l = in.nextInt() - 1;
                int k = in.nextInt() - 1;
                xLevels.get(l).remove(k);
                yLevels.get(l).remove(k);
                if (collapses(xLevels) || collapses(yLevels)) {
                    out.println("yes");
                    out.println(i + 1);
                    return;
                }
                debug("==============");
            }
            out.println("no");
        }

        private boolean collapses(final List<Level> levels) {
            debug("");
            long c = 0;
            long sx = 0;
            for (int i = levels.size() - 1; i >= 0; i--) {
                double centerX = sx / (double) c;
                Level level = levels.get(i);
                int minX = level.minX();
                int maxX = level.maxX();
                debug(i + " " + (level.cross ? "X" : " ") + " " + c + " " + minX + " " + centerX + " " + maxX);
                if (c > 0 && !level.cross && (sx <= minX * c || maxX * c <= sx)) {
                    return true;
                }
                c += levels.get(i).c();
                sx += levels.get(i).sumX();
            }
            return false;
        }

    }

    private static void debug(final String x) {
        System.out.println(x);
    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("jenga.in"));
        out = new PrintWriter("jenga.out");

        new Solution().run();

        in.close();
        out.close();
    }
}
