import java.io.OutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.InputStream;

/**
* Built using CHelper plug-in
* Actual solution is at the top
*/
public class jenga_ik {
public static void main(String[] args) {
InputStream inputStream;
try {
inputStream = new FileInputStream("jenga.in");
} catch (IOException e) {
throw new RuntimeException(e);
}
OutputStream outputStream;
try {
outputStream = new FileOutputStream("jenga.out");
} catch (IOException e) {
throw new RuntimeException(e);
}
InputReader in = new InputReader(inputStream);
PrintWriter out = new PrintWriter(outputStream);
jenga solver = new jenga();
solver.solve(1, in, out);
out.close();
}

static class jenga {
int n;
int w;
int h;
long[] mass;
boolean[][] dead;
int[] left;
int[] right;
int[] count;

private boolean unstable() {
long sx = 0, sy = 0, dx = 0, dy = 0;
for (int level = h - 1; level > 0; --level) {
if (level % 2 == 0) {
sx += 2L * mass[level];
dx += count[level];
sy += n * (long) count[level];
dy += count[level];
} else {
sy += 2L * mass[level];
dy += count[level];
sx += (n + 1) * (long) count[level];
dx += count[level];
}

if (dx == 0 && dy == 0) continue;
if (level % 2 == 0) {
int ly = left[level - 1] + 1, ry = right[level - 1] + 1;
// sy / dy / 2 <= ly
if (sy <= (2L * (long) ly - 1) * dy) return true;
if (sy >= (2L * (long) ry + 1) * dy) return true;
} else {
int lx = left[level - 1] + 1, rx = right[level - 1] + 1;
if (sx <= (2L * (long) lx - 1) * dx) return true;
if (sx >= (2L * (long) rx + 1) * dx) return true;
}
}
return false;
}

private void update(int level) {
while (left[level] < n && dead[level][left[level]])
++left[level];
while (right[level] >= 0 && dead[level][right[level]])
--right[level];
}

public void solve(int testNumber, InputReader in, PrintWriter out) {
n = in.nextInt();
w = in.nextInt();
h = in.nextInt();
dead = new boolean[h][n];
left = new int[h];
right = new int[h];
count = new int[h];
Arrays.fill(right, n - 1);
Arrays.fill(count, n);
int m = in.nextInt();

mass = new long[h];
for (int i = 0; i < h; ++i)
mass[i] = (long) n * (long) (n + 1) / 2L;

int res = -1;
for (int it = 0; it < m; ++it) {
int level = in.nextInt() - 1;
int pos = in.nextInt();
mass[level] -= pos;
dead[level][pos - 1] = true;
--count[level];
update(level);

if (res == -1 && unstable()) {
res = it;
}
}
if (res == -1) {
out.println("no");
} else {
out.println("yes\n" + (res + 1));
}
}

}

static class InputReader {
public BufferedReader reader;
public StringTokenizer tokenizer;

public InputReader(InputStream stream) {
reader = new BufferedReader(new InputStreamReader(stream), 32768);
tokenizer = null;
}

public String next() {
while (tokenizer == null || !tokenizer.hasMoreTokens()) {
try {
tokenizer = new StringTokenizer(reader.readLine());
} catch (IOException e) {
throw new RuntimeException(e);
}
}
return tokenizer.nextToken();
}

public int nextInt() {
return Integer.parseInt(next());
}

}
}