#include <cstdio>
#include <vector>
#include <cassert>

using namespace std;

typedef long long ll;

vector<int> sum;
vector<vector<bool>> have;
vector<int> cnt;
vector<int> minv, maxv;

int h, n;

bool check() {
  int h = sum.size();
  ll sumx, sumy, totcnt;
  sumx = sumy = totcnt = 0;
  for (int i = h - 1; i >= 0; i--) {
    if (i % 2) {
      if (totcnt > 0 && !(2 * minv[i] * totcnt < sumx && sumx < 2 * (maxv[i] + 1) * totcnt)) {
        return false;
      }
      sumy += n * cnt[i];
      sumx += sum[i];
      totcnt += cnt[i];
    } else {
      if (totcnt > 0 && !(2 * minv[i] * totcnt < sumy && sumy < 2 * (maxv[i] + 1) * totcnt)) {
        return false;
      }
      sumx += n * cnt[i];
      sumy += sum[i];
      totcnt += cnt[i];
    }
  }
  return true;
}

int main() {
  assert(freopen("jenga.in", "r", stdin));
  assert(freopen("jenga.out", "w", stdout));
  int w, m;
  assert(scanf("%d%d%d%d", &n, &w, &h, &m) == 4);
  {
    int sumv = 0;
    for (int i = 0; i < n; i++) {
      sumv += 2 * i + 1;
    }
    sum.resize(h, sumv);
  }
  have.resize(h, vector<bool>(n, true));
  cnt.resize(h, n);
  minv.resize(h, 0);
  maxv.resize(h, n - 1);

  for (int i = 0; i < m; i++) {
    int x, y;
    assert(scanf("%d%d", &x, &y) == 2);
    --x, --y;
    cnt[x] -= 1;
    sum[x] -= 2 * y + 1;
    have[x][y] = false;
    while (minv[x] <= maxv[x] && !have[x][minv[x]]) minv[x]++;
    while (maxv[x] >= minv[x] && !have[x][maxv[x]]) maxv[x]--;

    if (!check()) {
      printf("yes\n%d\n", i + 1);
      return 0;
    }
  }
  printf("no\n");
}

