import java.io.*;
import java.util.*;
 
public class jenga_sm {
    final static boolean DEBUG = false;
 
    class Point {
        long x, y;
        int count;
 
        public Point(Point p) {
            this(p.x, p.y, p.count);
        }
 
        public Point(long x, long y, int count) {
            this.x = x;
            this.y = y;
            this.count = count;
        }
 
        @Override
        public String toString() {
            return "Point{" +
                    "x=" + x +
                    ", y=" + y +
                    ", count=" + count +
                    '}';
        }
    }
 
    long getX(int level, int k) {
        long x, y;
        if (level % 2 == 0) {
            y = w * (n - 1) / 2;
            x = k * w;
        } else {
            x = w * (n - 1) / 2;
            y = k * w;
        }
        return x;
    }
 
    long getY(int level, int k) {
        long x, y;
        if (level % 2 == 0) {
            y = w * (n - 1) / 2;
            x = k * w;
        } else {
            x = w * (n - 1) / 2;
            y = k * w;
        }
        return y;
    }
 
    long getZ(int level, int k) {
        return 2 * level;
    }
 
    int n, h, m;
    long w;
 
    void solve() throws IOException {
        n = nextInt();
        w = nextInt() * 2;
        h = nextInt();
        m = nextInt();
        Point[] cm = new Point[h + 1];
        Point prev = new Point(0, 0, 0);
        for (int level = h - 1; level >= 0; level--) {
            prev.x += n * w * (n - 1) / 2;
            prev.y += n * w * (n - 1) / 2;
            prev.count += n;
            if (DEBUG) System.err.println("prev = " + prev);
            cm[level] = new Point(prev);
        }
        ArrayList<Integer>[] removed = new ArrayList[h];
        for (int i = 0; i < h; i++) {
            removed[i] = new ArrayList<>();
        }
        int[] qLevel = new int[m];
        int[] qK = new int[m];
        for (int it = 0; it < m; it++) {
            qLevel[it] = nextInt() - 1;
            qK[it] = nextInt() - 1;
            removed[qLevel[it]].add(qK[it]);
        }
        System.err.println(System.currentTimeMillis() -start);
        int[] minFilled = new int[h];
        int[] maxFilled = new int[h];
        int[] used = new int[n];
        for (int level = 0; level < h; level++) {
            for (int k : removed[level]) {
                used[k] = level + 1;
            }
            int minF = 0;
            while (minF < n && used[minF] == level + 1) {
                minF++;
            }
            int maxF = n  - 1;
            while (maxF >= 0 && used[maxF] == level + 1) {
                maxF--;
            }
            minFilled[level] = minF;
            maxFilled[level] = maxF;
        }
        int[] qMinF = new int[m];
        int[] qMaxF = new int[m];
        for (int it = m - 1; it >= 0; it--) {
            qMinF[it] = minFilled[qLevel[it]];
            qMaxF[it] = maxFilled[qLevel[it]];
            minFilled[qLevel[it]] = Math.min(minFilled[qLevel[it]], qK[it]);
            maxFilled[qLevel[it]] = Math.max(maxFilled[qLevel[it]], qK[it]);
        }
 
        System.err.println(System.currentTimeMillis() -start);
 
 
        for (int it = 0; it < m; it++) {
            if (DEBUG) System.err.println("");
            if (DEBUG) System.err.println("Iteration " + it);
            {
                int level = qLevel[it];
                int k = qK[it];
                if (DEBUG) System.err.println("level = " + level + " k = " + k);
                long x = getX(level, k);
                long y = getY(level, k);
                for (int iter_level = level; iter_level >= 0; iter_level--) {
                    cm[iter_level].x -= x;
                    cm[iter_level].y -= y;
                    cm[iter_level].count--;
                    if (DEBUG) System.err.println("cm[" + iter_level + "] = " + cm[iter_level]);
                }
 
                minFilled[level] = qMinF[it];
                maxFilled[level] = qMaxF[it];
                if (DEBUG) System.err.println("minFilled = " + Arrays.toString(minFilled));
                if (DEBUG) System.err.println("maxFilled = " + Arrays.toString(maxFilled));
            }
            for (int level = 0; level < h - 1; level++) {
//                cm[level + 1];
                long min = minFilled[level] * w - (w / 2);
                long max = maxFilled[level] * w + (w / 2);
                long minX, maxX, minY, maxY;
                if (level % 2 == 0) {
                    minX = min;
                    maxX = max;
 
                    minY = 0 - (w / 2);
                    maxY = (n - 1) * w + (w / 2);
                } else {
                    minX = 0 - (w / 2);
                    maxX = (n - 1) * w + (w / 2);
 
                    minY = min;
                    maxY = max;
                }
                if (DEBUG) System.err.println("level = " + level);
                if (DEBUG) System.err.println(" minX = " + minX + ", maxX = " + maxX);
                if (DEBUG) System.err.println(" minY = " + minY + ", maxY = " + maxY);
                long cnt = cm[level + 1].count;
                long x = cm[level + 1].x;
                long y = cm[level + 1].y;
                if (DEBUG) System.err.println(" cnt = " + cnt + " x = " + x + " y = " + y);
 
                if (minX * cnt < x && x < maxX * cnt &&
                        minY * cnt < y && y < maxY * cnt) {
 
                } else {
                    System.err.println("yes");
                    System.err.println(it + 1);
                    out.println("yes");
                    out.println(it + 1);
                    return;
                }
 
            }
        }
 
        out.println("no");
    }
 
    StringTokenizer st;
    BufferedReader br;
    PrintWriter out;
 
    int nextInt() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return Integer.parseInt(st.nextToken());
    }
 
    void run() throws IOException {
        br = new BufferedReader(new FileReader("jenga.in"));
        out = new PrintWriter("jenga.out");
        solve();
        out.close();
    }
    static long start;
 
    public static void main(String[] args) throws IOException {
        start = System.currentTimeMillis();
        new jenga_sm().run();
        System.err.println(System.currentTimeMillis() - start);
    }
}
