import java.io.*;
import java.util.*;
 
public class jenga_sm_wa_int32 {
    final static boolean DEBUG = false;
 
    class Point {
        long x, y, z;
        int count;
 
        public Point(Point p) {
            this(p.x, p.y, p.z, p.count);
        }
 
        public Point(long x, long y, long z, int count) {
            this.x = x;
            this.y = y;
            this.z = z;
            this.count = count;
        }
 
        @Override
        public String toString() {
            return "Point{" +
                    "x=" + x +
                    ", y=" + y +
                    ", z=" + z +
                    ", count=" + count +
                    '}';
        }
    }
 
    long getX(int level, int k) {
        long x, y;
        if (level % 2 == 0) {
            y = w * (n - 1) / 2;
            x = k * w;
        } else {
            x = w * (n - 1) / 2;
            y = k * w;
        }
        return x;
    }
 
    long getY(int level, int k) {
        long x, y;
        if (level % 2 == 0) {
            y = w * (n - 1) / 2;
            x = k * w;
        } else {
            x = w * (n - 1) / 2;
            y = k * w;
        }
        return y;
    }
 
    long getZ(int level, int k) {
        return 2 * level;
    }
 
    int n, w, h, m;
 
    void solve() throws IOException {
        n = nextInt();
        w = nextInt() * 2;
        h = nextInt();
        m = nextInt();
        Point[] cm = new Point[h + 1];
        Point prev = new Point(0, 0, 0, 0);
        for (int level = h - 1; level >= 0; level--) {
            prev.x += n * w * (n - 1) / 2;
            prev.y += n * w * (n - 1) / 2;
            prev.z += 2 * n;
            prev.count += n;
            if (DEBUG) System.err.println("prev = " + prev);
            cm[level] = new Point(prev);
        }
        Set<Integer>[] removed = new Set[h];
        int[] minFilled = new int[h];
        int[] maxFilled = new int[h];
        for (int i = 0; i < h; i++) {
            removed[i] = new HashSet<>();
            minFilled[i] = 0;
            maxFilled[i] = n - 1;
        }
        for (int it = 0; it < m; it++) {
            if (DEBUG) System.err.println("");
            if (DEBUG) System.err.println("Iteration " + it);
            {
                int level = nextInt() - 1;
                int k = nextInt() - 1;
                if (DEBUG) System.err.println("level = " + level + " k = " + k);
                for (int iter_level = level; iter_level >= 0; iter_level--) {
                    cm[iter_level].x -= getX(level, k);
                    cm[iter_level].y -= getY(level, k);
                    cm[iter_level].z -= getZ(level, k);
                    cm[iter_level].count--;
                    if (DEBUG) System.err.println("cm[" + iter_level + "] = " + cm[iter_level]);
                }
 
                removed[level].add(k);
                while (minFilled[level] <= n && removed[level].contains(minFilled[level])) {
                    minFilled[level]++;
                }
                while (maxFilled[level] >= -1 && removed[level].contains(maxFilled[level])) {
                    maxFilled[level]--;
                }
                if (DEBUG) System.err.println("minFilled = " + Arrays.toString(minFilled));
                if (DEBUG) System.err.println("maxFilled = " + Arrays.toString(maxFilled));
            }
            for (int level = 0; level < h - 1; level++) {
//                cm[level + 1];
                long min = minFilled[level] * w - (w / 2);
                long max = maxFilled[level] * w + (w / 2);
                long minX, maxX, minY, maxY;
                if (level % 2 == 0) {
                    minX = min;
                    maxX = max;
 
                    minY = 0 - (w / 2);
                    maxY = (n - 1) * w + (w / 2);
                } else {
                    minX = 0 - (w / 2);
                    maxX = (n - 1) * w + (w / 2);
 
                    minY = min;
                    maxY = max;
                }
                if (DEBUG) System.err.println("level = " + level);
                if (DEBUG) System.err.println(" minX = " + minX + ", maxX = " + maxX);
                if (DEBUG) System.err.println(" minY = " + minY + ", maxY = " + maxY);
                long cnt = cm[level + 1].count;
                long x = cm[level + 1].x;
                long y = cm[level + 1].y;
                if (DEBUG) System.err.println(" cnt = " + cnt + " x = " + x + " y = " + y);
 
                if (minX * cnt < x && x < maxX * cnt &&
                        minY * cnt < y && y < maxY * cnt) {
 
                } else {
                    System.err.println("yes");
                    System.err.println(it + 1);
                    out.println("yes");
                    out.println(it + 1);
                    return;
                }
 
            }
        }
 
        out.println("no");
    }
 
    StringTokenizer st;
    BufferedReader br;
    PrintWriter out;
 
    int nextInt() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return Integer.parseInt(st.nextToken());
    }
 
    void run() throws IOException {
        br = new BufferedReader(new FileReader("jenga.in"));
        out = new PrintWriter("jenga.out");
        solve();
        out.close();
    }
 
    public static void main(String[] args) throws IOException {
        new jenga_sm_wa_int32().run();
    }
}
