import javafx.util.Pair;

import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.Scanner;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class kids_gk {
    static Scanner in;
    static PrintWriter out;

    static class P {
        int x, y;

        P(final int x, final int y) {
            this.x = x;
            this.y = y;
        }

        P subtract(P p) {
            return new P(x - p.x, y - p.y);
        }

        @Override
        public String toString() {
            return "(" + x + ", " + y + ")";
        }

        P add(final P p) {
            return new P(x + p.x, y + p.y);
        }
    }

    static Comparator<P> COMPARATOR = Comparator.<P>comparingInt(p -> p.y).thenComparing(p -> p.x);

    static class Solution {
        void run() {
            Pair<P, List<P>> a = read();
            Pair<P, List<P>> b = read();
            Pair<P, List<P>> c = read();
            if (xor(xor(a, b), c).getValue().isEmpty()) {
                yes(subtract(a, b));
            } else if (xor(xor(a, c), b).getValue().isEmpty()) {
                yes(subtract(a, b).add(xor(a, c).getKey()));
            } else if (xor(xor(b, c), a).getValue().isEmpty()) {
                yes(subtract(a, b).subtract(xor(b, c).getKey()));
            } else {
                out.println("NO");
            }
        }

        private P subtract(final Pair<P, List<P>> a, final Pair<P, List<P>> b) {
            return a.getKey().subtract(b.getKey());
        }

        private void yes(final P p) {
            out.println("YES");
            out.println(p.x + " " + p.y);
        }

        private Pair<P, List<P>> xor(Pair<P, List<P>> ap, Pair<P, List<P>> bp) {
            final List<P> a = ap.getValue();
            final List<P> b = bp.getValue();
            List<P> c = new ArrayList<>();
            int ai = 0;
            int bi = 0;
            while (ai < a.size() && bi < b.size()) {
                switch (COMPARATOR.compare(a.get(ai), b.get(bi))) {
                    case 0:
                        ai++;
                        bi++;
                        break;
                    case -1:
                        c.add(a.get(ai++));
                        break;
                    case 1:
                        c.add(b.get(bi++));
                        break;
                }
            }
            while (ai < a.size()) {
                c.add(a.get(ai++));
            }
            while (bi < b.size()) {
                c.add(b.get(bi++));
            }
//            System.out.println(a.size() + " " + b.size() + " -> " + c.size());
            if (c.isEmpty()) {
                return new Pair<>(new P(0, 0), c);
            }
            P origin = c.get(0);
//            System.out.println(c);
            return new Pair<>(
                    origin,
                    c.stream().map(p -> p.subtract(origin)).collect(Collectors.toList())
            );
        }

        private List<P> xor(final List<P> a, final List<P> b) {
            List<P> c = new ArrayList<>();
            int ai = 0;
            int bi = 0;
            while (ai < a.size() && bi < b.size()) {
                switch (COMPARATOR.compare(a.get(ai), b.get(bi))) {
                    case 0:
                        ai++;
                        bi++;
                        break;
                    case -1:
                        c.add(a.get(ai++));
                        break;
                    case 1:
                        c.add(b.get(bi++));
                        break;
                }
            }
            while (ai < a.size()) {
                c.add(a.get(ai++));
            }
            while (bi < b.size()) {
                c.add(b.get(bi++));
            }
            if (c.isEmpty()) {
                return c;
            }
            P origin = c.get(0);
            return c.stream().map(p -> p.subtract(origin)).collect(Collectors.toList());
        }

        private Pair<P, List<P>> read() {
            int h = in.nextInt();
            int w = in.nextInt();
            in.nextLine();
            char[][] read = Stream.generate(() -> in.nextLine().toCharArray()).limit(h).toArray(char[][]::new);
            List<P> points = new ArrayList<>();
            P origin = null;
            for (int y = 0; y < h; y++) {
                for (int x = 0; x < w; x++) {
                    if (read[y][x] == '*') {
                        if (origin == null) {
                            origin = new P(x, y);
                        }
                        points.add(new P(x, y).subtract(origin));
                    }
                }
            }
            return new Pair<>(origin == null ? new P(0, 0) : origin, points);
        }
    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("kids.in"));
        out = new PrintWriter("kids.out");

        new Solution().run();

        in.close();
        out.close();
    }
}
