import java.io.OutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.InputStream;
 
/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class kids_petr_wa_twosides {
    public static void main(String[] args) {
        InputStream inputStream;
        try {
            inputStream = new FileInputStream("kids.in");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("kids.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        Kids solver = new Kids();
        solver.solve(1, in, out);
        out.close();
    }
 
    static class Kids {
        int resr = Integer.MIN_VALUE;
        int resc = Integer.MIN_VALUE;
 
        static Picture readPicture(InputReader in) {
            int rows = in.nextInt();
            int cols = in.nextInt();
            String[] field = new String[rows];
            for (int r = 0; r < rows; ++r) {
                field[r] = in.next();
            }
            int minr = rows;
            int maxr = -1;
            int minc = cols;
            int maxc = -1;
            for (int r = 0; r < rows; ++r) {
                for (int c = 0; c < cols; ++c) {
                    if (field[r].charAt(c) == '*') {
                        minr = Math.min(minr, r);
                        maxr = Math.max(maxr, r);
                        minc = Math.min(minc, c);
                        maxc = Math.max(maxc, c);
                    }
                }
            }
            if (minr > maxr) {
                return new Picture(0, 0, 0, 0);
            }
            Picture p = new Picture(maxr - minr + 1, maxc - minc + 1, minr, minc);
            for (int r = 0; r < rows; ++r) {
                for (int c = 0; c < cols; ++c) {
                    if (field[r].charAt(c) == '*') {
                        p.data[r - minr][c - minc] = true;
                        ++p.total;
                    }
                }
            }
            return p;
        }
 
        public void solve(int testNumber, InputReader in, PrintWriter out) {
            Picture p1 = readPicture(in);
            Picture p2 = readPicture(in);
            Picture p3 = readPicture(in);
            if (p1.total == 0) {
                if (same(p2, p3)) {
                    resr = 0;
                    resc = 0;
                } else {
                    out.println("NO");
                    return;
                }
            } else if (p2.total == 0) {
                if (same(p1, p3)) {
                    resr = 0;
                    resc = 0;
                } else {
                    out.println("NO");
                    return;
                }
            } else if (p3.total == 0) {
                if (same(p1, p2)) {
                    resr = 0;
                    resc = 0;
                } else {
                    out.println("NO");
                    return;
                }
            } else {
                doit(p1, p2, p3, 0, 0);
                doit(p1, p2, p3, p3.rows - p1.rows, 0);
                doit(p1, p2, p3, 0, p3.cols - p1.cols);
                doit(p1, p2, p3, p3.rows - p1.rows, p3.rows - p1.rows);
                if (resr == Integer.MIN_VALUE) {
                    Picture t = p1;
                    p1 = p2;
                    p2 = t;
                    doit(p1, p2, p3, 0, 0);
                    doit(p1, p2, p3, p3.rows - p1.rows, 0);
                    doit(p1, p2, p3, 0, p3.cols - p1.cols);
                    doit(p1, p2, p3, p3.rows - p1.rows, p3.rows - p1.rows);
                    t = p1;
                    p1 = p2;
                    p2 = t;
                    if (resr == Integer.MIN_VALUE) {
                        doit(p1, p3, p2, 0, 0);
                        if (resr == Integer.MIN_VALUE) {
                            out.println("NO");
                            return;
                        } else {
                            resr = 0;
                            resc = 0;
                        }
                    }
                    resr = -resr;
                    resc = -resc;
                }
            }
            out.println("YES");
            out.println((resc - p2.savedMinc + p1.savedMinc) + " " + (resr - p2.savedMinr + p1.savedMinr));
        }
 
        private boolean same(Picture a, Picture b) {
            if (a.total != b.total) return false;
            if (a.rows != b.rows) return false;
            if (a.cols != b.cols) return false;
            for (int r = 0; r < a.rows; ++r)
                for (int c = 0; c < a.cols; ++c)
                    if (a.data[r][c] != b.data[r][c]) return false;
            return true;
        }
 
        private void doit(Picture p1, Picture p2, Picture p3, int or, int oc) {
            int minr = Integer.MAX_VALUE;
            int minc = Integer.MAX_VALUE;
            int maxr = Integer.MIN_VALUE;
            int maxc = Integer.MIN_VALUE;
            int total = 0;
            for (int r1 = 0; r1 < p1.rows; ++r1) {
                for (int c1 = 0; c1 < p1.cols; ++c1) {
                    boolean have = p1.data[r1][c1];
                    int r3 = r1 + or;
                    int c3 = c1 + oc;
                    if (r3 >= 0 && r3 < p3.rows && c3 >= 0 && c3 < p3.cols) {
                        have ^= p3.data[r3][c3];
                    }
                    if (have) {
                        minr = Math.min(minr, r3);
                        maxr = Math.max(maxr, r3);
                        minc = Math.min(minc, c3);
                        maxc = Math.max(maxc, c3);
                        ++total;
                    }
                }
            }
            for (int r3 = 0; r3 < p3.rows; ++r3) {
                for (int c3 = 0; c3 < p3.cols; ++c3) {
                    boolean have = p3.data[r3][c3];
                    int r1 = r3 - or;
                    int c1 = c3 - oc;
                    if (r1 >= 0 && r1 < p1.rows && c1 >= 0 && c1 < p1.cols) {
                        continue;
                    }
                    if (have) {
                        minr = Math.min(minr, r3);
                        maxr = Math.max(maxr, r3);
                        minc = Math.min(minc, c3);
                        maxc = Math.max(maxc, c3);
                        ++total;
                    }
                }
            }
            if (maxr - minr + 1 != p2.rows) return;
            if (maxc - minc + 1 != p2.cols) return;
            if (total != p2.total) return;
            for (int r1 = 0; r1 < p1.rows; ++r1) {
                for (int c1 = 0; c1 < p1.cols; ++c1) {
                    boolean have = p1.data[r1][c1];
                    int r3 = r1 + or;
                    int c3 = c1 + oc;
                    if (r3 >= 0 && r3 < p3.rows && c3 >= 0 && c3 < p3.cols) {
                        have ^= p3.data[r3][c3];
                    }
                    if (have) {
                        if (!p2.data[r3 - minr][c3 - minc]) return;
                    }
                }
            }
            for (int r3 = 0; r3 < p3.rows; ++r3) {
                for (int c3 = 0; c3 < p3.cols; ++c3) {
                    boolean have = p3.data[r3][c3];
                    int r1 = r3 - or;
                    int c1 = c3 - oc;
                    if (r1 >= 0 && r1 < p1.rows && c1 >= 0 && c1 < p1.cols) {
                        continue;
                    }
                    if (have) {
                        if (!p2.data[r3 - minr][c3 - minc]) return;
                    }
                }
            }
            resr = minr - or;
            resc = minc - oc;
        }
 
        static class Picture {
            int rows;
            int cols;
            int total = 0;
            int savedMinr;
            int savedMinc;
            boolean[][] data;
 
            public Picture(int rows, int cols, int savedMinr, int savedMinc) {
                this.rows = rows;
                this.cols = cols;
                this.savedMinr = savedMinr;
                this.savedMinc = savedMinc;
                data = new boolean[rows][cols];
            }
 
        }
 
    }
 
    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;
 
        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }
 
        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }
 
        public int nextInt() {
            return Integer.parseInt(next());
        }
 
    }
}