#include <cstdio>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;


typedef vector<pair<int, int>> cells;

cells shift(const cells& a, int x, int y) {
  cells res(a.size());
  for (int i = 0; i < (int)a.size(); i++) {
    res[i] = make_pair(a[i].first + x, a[i].second + y);
  }
  return res;
}

cells get_xor(const cells& a, const cells& b) {
  cells res;
  res.resize(a.size() + b.size());
  merge(a.begin(), a.end(), b.begin(), b.end(), res.begin());
  int ptr = 0;
  for (int i = 0; i < res.size(); i++) {
    if (!i || res[i] != res[i-1]) {
      res[ptr++] = res[i];
    } else {
      ptr--;
    }
  }
  res.resize(ptr);
  return res;
}

cells get() {
  int n, m;
  assert(scanf("%d %d", &n, &m) == 2);
  static char buf[1010];
  cells res;
  for (int i = 0; i < n; i++) {
    assert(scanf("%s", buf));
    for (int j = 0; j < m; j++) {
      if (buf[j] == '*') {
        res.push_back(make_pair(i, j));
      }
    }
  }
  return res;
}

int main() {
  assert(freopen("kids.in", "r", stdin));
  assert(freopen("kids.out", "w", stdout));

  cells a = get();
  cells b = get();
  cells c = get();

  vector<int> sx, sy;
  sx.push_back(0);
  sy.push_back(0);

  if (!a.empty() && !b.empty()) {
    sx.push_back(a[0].first - b[0].first);
    sy.push_back(a[0].second - b[0].second);
  }
  
  if (!a.empty() && !c.empty() && !b.empty()) {
    int s1x = a[0].first - c[0].first;
    int s1y = a[0].second - c[0].second;
    cells temp = get_xor(a, shift(c, s1x, s1y));
    if (!temp.empty()) {
      sx.push_back(temp[0].first - b[0].first);
      sy.push_back(temp[0].second - b[0].second);
    }
  }
  
  if (!a.empty() && !c.empty() && !b.empty()) {
    int s1x = b[0].first - c[0].first;
    int s1y = b[0].second - c[0].second;
    cells temp = get_xor(b, shift(c, s1x, s1y));
    if (!temp.empty()) {
      sx.push_back(a[0].first - temp[0].first);
      sy.push_back(a[0].second - temp[0].second);
    }
  }
  
  for (int i = 0; i < sx.size(); i++) {
    cells x = get_xor(a, shift(b, sx[i], sy[i]));
    int s1x = (x.empty() || c.empty()) ? 0 : (c[0].first - x[0].first);
    int s1y = (x.empty() || c.empty()) ? 0 : (c[0].second - x[0].second);
    if (shift(x, s1x, s1y) == c) {
      printf("YES\n%d %d\n", sy[i], sx[i]);
      return 0;
    }
  }

  printf("NO\n");
  return 0;
}

