import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * @author: pashka
 */
public class kids_pm {

    void run() throws FileNotFoundException {
        Scanner in = new Scanner(new File("kids.in"));
        PrintWriter out = new PrintWriter("kids.out");
        Picture[] pictures = new Picture[3];
        for (int i = 0; i < 3; i++) pictures[i] = readPicture(in);
        int[][] d = solve(pictures);
        if (d == null) {
            out.println("NO");
        } else {
            out.println("YES");
            out.println((d[1][1] - d[0][1]) + " " + (d[1][0] - d[0][0]));
        }
        out.close();
    }

    private int[][] solve(Picture[] pictures) {
        if (pictures.length == 0) {
            return new int[0][2];
        } else {
            Picture[] pp = new Picture[pictures.length - 1];
            int[][] res = new int[pictures.length][2];
            for (int i = 0; i < pictures.length; i++) {
                if (pictures[i].n == 0) {
                    System.arraycopy(pictures, 0, pp, 0, i);
                    System.arraycopy(pictures, i + 1, pp, i, pictures.length - i - 1);
                    int[][] rr = solve(pp);
                    if (rr == null) return null;
                    System.arraycopy(rr, 0, res, 0, i);
                    System.arraycopy(rr, i, res, i + 1, pictures.length - i - 1);
                    return res;
                }
            }
            for (int i = 0; i < pictures.length; i++) {
                for (int j = i + 1; j < pictures.length; j++) {
                    System.arraycopy(pictures, 0, pp, 0, j);
                    System.arraycopy(pictures, j + 1, pp, j, pictures.length - j - 1);
                    pp[i] = merge(pictures[i], pictures[j]);
                    int[][] rr = solve(pp);
                    if (rr == null) continue;
                    System.arraycopy(rr, 0, res, 0, j);
                    System.arraycopy(rr, j, res, j + 1, pictures.length - j - 1);
                    res[j][0] = res[i][0] + pictures[i].r[0] - pictures[j].r[0];
                    res[j][1] = res[i][1] + pictures[i].c[0] - pictures[j].c[0];
                    return res;
                }
            }
        }
        return null;
    }

    private Picture merge(Picture a, Picture b) {
        if (a.n == 0) {
            return b;
        } else if (b.n == 0) {
            return a;
        }
        Picture res = new Picture();
        res.r = new int[a.n + b.n];
        res.c = new int[a.n + b.n];
        int i = 0, j = 0;
        int dr = a.r[0] - b.r[0];
        int dc = a.c[0] - b.c[0];
        while (i < a.n || j < b.n) {
            int r1 = i < a.n ? a.r[i] : Integer.MAX_VALUE;
            int c1 = i < a.n ? a.c[i] : Integer.MAX_VALUE;
            int r2 = j < b.n ? b.r[j] + dr : Integer.MAX_VALUE;
            int c2 = j < b.n ? b.c[j] + dc : Integer.MAX_VALUE;
            if (r1 == r2 && c1 == c2) {
                i++;
                j++;
            } else if (r1 < r2 || (r1 == r2) && (c1 < c2)) {
                res.r[res.n] = r1;
                res.c[res.n] = c1;
                i++;
                res.n++;
            } else {
                res.r[res.n] = r2;
                res.c[res.n] = c2;
                j++;
                res.n++;
            }
        }
        return res;
    }

    Picture readPicture(Scanner in) {
        int h = in.nextInt();
        int w = in.nextInt();
        Picture picture = new Picture();
        picture.r = new int[h * w];
        picture.c = new int[h * w];
        for (int i = 0; i < h; i++) {
            String s = in.next();
            for (int j = 0; j < w; j++) {
                if (s.charAt(j) == '*') {
                    picture.r[picture.n] = i;
                    picture.c[picture.n] = j;
                    picture.n++;
                }
            }
        }
        return picture;
    }

    public static void main(String[] args) throws FileNotFoundException {
        new kids_pm().run();
    }

    static class Picture {
        int n;
        int[] r;
        int[] c;
    }
}
