import java.io.File;
import java.io.PrintWriter;
import java.util.*;
import java.util.stream.Collectors;

public class list_gk {
    static Scanner in;
    static PrintWriter out;
    static int MAX = 2100;

    static class Solution {
        List<Integer> primes = new ArrayList<>();
        long aa, bb, cc;
        int ops;

        void run() {
            primes.add(2);
            next: for (int i = 3; i <= MAX; i += 2) {
                for (int p : primes) {
                    if (p * p > i) {
                        break;
                    } else if (i % p == 0) {
                        continue next;
                    }
                }
                primes.add(i);
            }
            primes.add(MAX + 1);

            aa = in.nextLong() - 1;
            bb = in.nextLong();

            Deque<Integer> pi = new ArrayDeque<>();
            for (int sum = 1; sum <= MAX; sum++) {
                solve(pi, 0, sum);
            }
            System.out.println(ops);
        }

        void solve(Deque<Integer> pi, int pl, int tail) {
            if (cc > bb || tail < 0) {
                return;
            }

            long length = length(pi, pl, tail);
            if (cc + length < aa) {
                cc += length;
                return;
            }

            if (tail == 0) {
                String str = pi.stream().map(primes::get).collect(Collectors.toList()) + ", ";
                String substring = str.substring((int) Math.max(aa - cc, 0), (int) Math.min(bb - cc, str.length()));
                out.print(substring);
                cc += str.length();
                return;
            }

            for (int fpi = pi.isEmpty() ? 0 : pi.getLast() + 1; fpi < primes.size(); fpi++) {
                int fp = primes.get(fpi);
                if (fp > tail) {
                    break;
                }
                pi.addLast(fpi);
                solve(pi, pl + (fp + ", ").length(), tail - fp);
                pi.removeLast();
            }
        }

        long length(Deque<Integer> pi, int pl, int tail) {
            long[] count = new long[tail + 1];
            long[] length = new long[tail + 1];
            count[0] = 1;
            length[0] = pl + 2;
            for (int p : primes.subList(pi.isEmpty() ? 0 : pi.getLast() + 1, primes.size())) {
                if (p > tail) {
                    break;
                }

                long mp = 2 + ("" + p).length();
                for (int j = tail - p; j >= 0; j--) {
                    ops++;
                    count[j + p] += count[j];
                    length[j + p] += length[j] + count[j] * mp;
                }
            }
            return length[tail];
        }

    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("list.in"));
        out = new PrintWriter("list.out");

        new Solution().run();

        in.close();
        out.close();
    }
}
