import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.stream.Collectors;

public class list_gk_ok_hard {
    static Scanner in;
    static PrintWriter out;
    static int MAX = 2100;

    static class Solution {
        List<Integer> primes = new ArrayList<>();

        void run() {
            primes.add(2);
            next: for (int i = 3; i <= MAX; i += 2) {
                for (int p : primes) {
                    if (p * p > i) {
                        break;
                    } else if (i % p == 0) {
                        continue next;
                    }
                }
                primes.add(i);
            }
            primes.add(MAX + 1);

            long a = in.nextLong() - 1;
            int len = (int) (in.nextLong() - a);

            long[] count = new long[MAX + 1];
            long[] length = new long[MAX + 1];
            int i = 0;
            for (int p = 0; p <= MAX; p++) {
                if (p == primes.get(i)) {
                    i++;
                    int pl = len(p);
                    update(count, length, p, MAX);
                    count[p] += 1;
                    length[p] += 4 + pl;
                }
                if (a < length[p]) {
                    out.println(solve(a, len, new ArrayList<>(), p));
                    return;
                }
                a -= length[p];
            }
        }

        int len(int p) {
            return ("" + p).length();
        }

        List<Integer> first(List<Integer> pi, int rest) {
            if (rest == 0) {
                return pi;
            }
            if (rest < 0) {
                return null;
            }
            for (int npi = pi.isEmpty() ? 0 : pi.get(pi.size() - 1) + 1; ; npi++) {
                Integer np = primes.get(npi);
                if (np > rest) {
                    return null;
                }
                List<Integer> z = new ArrayList<>(pi);
                z.add(npi);
                z = first(z, rest - np);
                if (z != null) {
                    return z;
                }
            }
        }

        List<Integer> next(List<Integer> pi) {
            pi = new ArrayList<>(pi);
            int rest = 0;
            while (!pi.isEmpty()) {
                rest += primes.get(pi.get(pi.size() - 1));
                for (int npi = pi.get(pi.size() - 1) + 1; primes.get(npi) <= rest; npi++) {
                    pi.set(pi.size() - 1, npi);
                    List<Integer> first = first(pi, rest - primes.get(npi));
                    if (first != null) {
                        return first;
                    }
                }
                pi = pi.subList(0, pi.size() - 1);
            }
            while (true) {
                pi = first(new ArrayList<>(), ++rest);
                if (pi != null) {
                    return pi;
                }
            }
        }

        String render(List<Integer> pi) {
            return pi.stream().map(primes::get).collect(Collectors.toList()) + ", ";
        }

        String solve(long a, int len, List<Integer> pi, int sum) {
            if (len <= 0) {
                return "";
            }
            int cSum = pi.stream().mapToInt(primes::get).sum();
            if (sum == cSum) {
                String str = "";
                while (str.length() < a + len && pi != null) {
                    str += render(pi);
                    pi = next(pi);
                }
                return str.substring((int) a, (int) a + len);
            }

            int cLength = render(pi).length() + (pi.isEmpty() ? 0 : 2);
            for (int fpi = pi.isEmpty() ? 0 : pi.get(pi.size() - 1) + 1; fpi < primes.size(); fpi++) {
                int fp = primes.get(fpi);
                int fpSum = fp + cSum;
                if (fpSum > sum) {
                    break;
                }
                long[] count = new long[sum + 1];
                long[] length = new long[sum + 1];
                count[fpSum] = 1;
                pi.add(fpi);
                length[fpSum] = cLength + len(fp);
                for (int p : primes.subList(fpi + 1, primes.size())) {
                    if (p + fpSum > sum) {
                        break;
                    }

                    update(count, length, p, sum);
                }
                if (a < length[sum]) {
                    return solve(a, len, pi, sum);
                }
                a -= length[sum];
                pi.remove(pi.size() - 1);
            }
            return solve(a, len, new ArrayList<>(), sum + 1);
        }

        void update(long[] count, long[] length, int p, int sum) {
            int mp = 2 + len(p);
            for (int j = sum - p; j >= 0; j--) {
                count[j + p] += count[j];
                length[j + p] += length[j] + count[j] * mp;
            }
        }

    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("list.in"));
        out = new PrintWriter("list.out");

        new Solution().run();

        in.close();
        out.close();
    }
}
