import java.io.File;
import java.io.PrintWriter;
import java.util.*;
import java.util.stream.Collectors;

public class list_gk_ok_precalc {
    static Scanner in;
    static PrintWriter out;
    static int MAX = 2100;

    static class Solution {
        List<Integer> primes = new ArrayList<>();
        long aa, bb, cc;
        StringBuilder sb = new StringBuilder();

        void run() {
            primes.add(2);
            next: for (int i = 3; i <= MAX; i += 2) {
                for (int p : primes) {
                    if (p * p > i) {
                        break;
                    } else if (i % p == 0) {
                        continue next;
                    }
                }
                primes.add(i);
            }

            aa = in.nextLong() - 1;
            bb = in.nextLong();

            precalc();
            Deque<Integer> pi = new ArrayDeque<>();
            for (int sum = 1; sum <= MAX; sum++) {
                solve(pi, 0, sum);
            }
            out.println(sb);
        }

        void solve(Deque<Integer> pi, int pl, int tail) {
            if (cc >= bb || tail < 0) {
                return;
            }

            int i = pi.isEmpty() ? 0 : pi.getLast() + 1;
            long len = pl * count[i][tail] + length[i][tail];
            if (cc + len < aa) {
                cc += len;
                return;
            }

            if (tail == 0) {
                String str = pi.stream().map(primes::get).collect(Collectors.toList()) + ", ";
                sb.append(str.substring((int) Math.max(aa - cc, 0), (int) Math.min(bb - cc, str.length())));
                cc += str.length();
                return;
            }

            for (int fpi = i; fpi < primes.size() && cc < bb; fpi++) {
                int fp = primes.get(fpi);
                if (fp > tail) {
                    break;
                }
                pi.addLast(fpi);
                solve(pi, pl + (fp + ", ").length(), tail - fp);
                pi.removeLast();
            }
        }

        long[][] count;
        long[][] length;

        void precalc() {
            count = new long[primes.size() + 1][MAX + 1];
            length = new long[primes.size() + 1][MAX + 1];
            count[primes.size()][0] = 1;
            length[primes.size()][0] = 2;
            for (int i = primes.size() - 1; i >= 0; i--) {
                count[i] = count[i + 1].clone();
                length[i] = length[i + 1].clone();
                int p = primes.get(i);
                long mp = (p + ", ").length();
                for (int j = 0; j <= MAX - p; j++) {
                    count[i][j + p] += count[i + 1][j];
                    length[i][j + p] += length[i + 1][j] + count[i + 1][j] * mp;
                }
            }
        }
    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("list.in"));
        out = new PrintWriter("list.out");

        new Solution().run();

        in.close();
        out.close();
    }
}
