import java.io.File;
import java.io.PrintWriter;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class list_gk_tl_naive {
    private static Scanner in;
    private static PrintWriter out;
    private static final int MAX = 100;

    private static class Solution {
        final List<Integer> primes = new ArrayList<>();

        void run() {
            primes.add(2);
            next: for (int i = 3; i <= MAX; i += 2) {
                for (int p : primes) {
                    if (p * p > i) {
                        break;
                    } else if (i % p == 0) {
                        continue next;
                    }
                }
                primes.add(i);
            }
            primes.add(MAX + 1);
            List<List<Integer>> lists = collect(0, MAX)
                    .filter(l -> !l.isEmpty())
                    .map(l -> {
                        Collections.reverse(l);
                        return l;
                    })
                    .sorted(Comparator.<List<Integer>>comparingLong(l -> l.stream().mapToInt(i -> i).sum()).thenComparing((l, r) -> {
                        for (int i = 0; i < Math.min(l.size(), r.size()); i++) {
                            int c = Integer.compare(l.get(i), r.get(i));
                            if (c != 0) {
                                return c;
                            }
                        }
                        return Integer.compare(l.size(), r.size());
                    }))
                    .collect(Collectors.toList());
            String str = lists.toString();
            System.out.println(str.length());
            out.println(str.substring(in.nextInt(), in.nextInt() + 1));
        }

        private Stream<List<Integer>> collect(int i, final int max) {
            final Integer p = primes.get(i);
            if (p > max) {
                return Stream.of(new ArrayList<Integer>());
            }
            return Stream.concat(
                    collect(i + 1, max - p).map(l -> {
                        l.add(p);
                        return l;
                    }),
                    collect(i + 1, max)
            );
        }
    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("list.in"));
        out = new PrintWriter("list.out");

        new Solution().run();

        in.close();
        out.close();
    }
}
