import java.io.*;
import java.util.*;

public class list_md_naive_tl {
	public static final int MAX_SUM = 70;
	int[] primes;

	public void run() {
		precalcPrimes(MAX_SUM);
		long a = in.nextLong() - 1;
		long b = in.nextLong();
		ArrayList<PrimeSet> sets = new ArrayList<>();
		for (int mask = 1; mask < (1 << primes.length); mask++) {
			int[] data = new int[Integer.bitCount(mask)];
			for (int j = 0, k = 0; j < primes.length; j++) {
				if (((mask >> j) & 1) > 0) {
					data[k++] = primes[j];
				}
			}
			sets.add(new PrimeSet(data));
		}
		Collections.sort(sets);
		out.print(sets.toString().substring((int) a + 1, (int) b + 1));
	}
	
	class PrimeSet implements Comparable<PrimeSet> {
		int[] data;
		int sum;

		public PrimeSet(int[] data) {
			this.data = data;
			for (int p : data) {
				sum += p;
			}
		}

		@Override
		public int compareTo(PrimeSet that) {
			if (sum != that.sum) {
				return sum - that.sum;
			}
			for (int i = 0;; i++) {
				if (data[i] != that.data[i]) {
					return data[i] - that.data[i];
				}
			}
		}
		
		@Override
		public String toString() {
			return Arrays.toString(data);
		}
	}

	void precalcPrimes(int n) {
		boolean[] isPrime = new boolean[n + 1];
		for (int i = 2; i <= n; i++) {
			isPrime[i] = true;
		}
		for (int i = 2, j; (j = i * i) <= n; i++) {
			if (!isPrime[i]) {
				continue;
			}
			do {
				isPrime[j] = false;
				j += i;
			} while (j <= n);
		}
		int m = 0;
		for (int i = 2; i <= n; i++) {
			if (isPrime[i]) {
				m++;
			}
		}
		primes = new int[m];
		m = 0;
		for (int i = 2; i <= n; i++) {
			if (isPrime[i]) {
				primes[m] = i;
				m++;
			}
		}
	}

	static Scanner in;
	static PrintWriter out;

	public static void main(String[] args) throws IOException {
		String fileName = list_md_naive_tl.class.getSimpleName().replaceFirst("_.*", "").toLowerCase();
		String inputFileName = fileName + ".in";
		String outputFileName = fileName + ".out";

		Locale.setDefault(Locale.US);
		in = new Scanner(new File(inputFileName));
		out = new PrintWriter(outputFileName);
		new list_md_naive_tl().run();
		in.close();
		out.close();
	}
}
