import java.io.*;
import java.util.*;

public class list_md_wa4 {
	public static final int MAX_SUM = 2096;
	int[] primes;
	long[][] len, count;
	long skip, print;

	public void run() {
		precalcPrimes(MAX_SUM);
		precalcLen();
		skip = in.nextLong() - 1;
		print = in.nextLong() - skip;
		for (int sum = 1; print > 0; sum++) {
			if (sum > MAX_SUM) {
				throw new RuntimeException("Insufficient MAX_PRIME");
			}
			search(sum, 0, new ArrayList<Integer>());
		}
	}

	void search(int sum, int x, ArrayList<Integer> prefix) {
		long here = len[x][sum];
		if (!prefix.isEmpty()) {
			here += count[x][sum] * prefix.toString().length();
		}
		if (print == 0 || sum < 0 || here == 0) {
			return;
		}
		if (here <= skip) {
			skip -= here;
			return;
		}
		if (sum == 0) {
			String s = (prefix + ", ");
			s = s.substring((int) skip, Math.min((int) (skip + print), s.length()));
			print -= s.length();
			out.print(s);
			return;
		}
		prefix.add(primes[x]);
		search(sum - primes[x], x + 1, prefix);
		prefix.remove(prefix.size() - 1);
		search(sum, x + 1, prefix);
	}

	void precalcLen() {
		count = new long[primes.length + 1][MAX_SUM + 1];
		len = new long[primes.length + 1][MAX_SUM + 1];
		for (int i = primes.length; i >= 0; i--) {
			count[i][0] = 1;
			len[i][0] = 2;
		}
		for (int i = primes.length - 1; i >= 0; i--) {
			int characters = 2 + ("" + primes[i]).length();
			for (int j = 1; j <= MAX_SUM; j++) {
				count[i][j] = count[i + 1][j];
				len[i][j] = len[i + 1][j];
				if (j >= primes[i]) {
					count[i][j] += count[i + 1][j - primes[i]];
					len[i][j] += len[i + 1][j - primes[i]] + count[i + 1][j - primes[i]] * characters;
				}
			}
		}
	}

	void precalcPrimes(int n) {
		boolean[] isPrime = new boolean[n + 1];
		for (int i = 2; i <= n; i++) {
			isPrime[i] = true;
		}
		for (int i = 2, j; (j = i * i) <= n; i++) {
			if (!isPrime[i]) {
				continue;
			}
			do {
				isPrime[j] = false;
				j += i;
			} while (j <= n);
		}
		int m = 0;
		for (int i = 2; i <= n; i++) {
			if (isPrime[i]) {
				m++;
			}
		}
		primes = new int[m];
		m = 0;
		for (int i = 2; i <= n; i++) {
			if (isPrime[i]) {
				primes[m] = i;
				m++;
			}
		}
	}

	static Scanner in;
	static PrintWriter out;

	public static void main(String[] args) throws IOException {
		String fileName = list_md_wa4.class.getSimpleName().replaceFirst("_.*", "").toLowerCase();
		String inputFileName = fileName + ".in";
		String outputFileName = fileName + ".out";

		Locale.setDefault(Locale.US);
		in = new Scanner(new File(inputFileName));
		out = new PrintWriter(outputFileName);
		new list_md_wa4().run();
		in.close();
		out.close();
	}
}
