import java.io.OutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.StringTokenizer;
import java.io.BufferedReader;
import java.util.Collections;
import java.io.InputStream;
 
/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class list_petr {
    public static void main(String[] args) {
        InputStream inputStream;
        try {
            inputStream = new FileInputStream("list.in");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("list.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        List solver = new List();
        solver.solve(1, in, out);
        out.close();
    }
 
    static class List {
        int BUBEN = 2200;
 
        public void solve(int testNumber, InputReader in, PrintWriter out) {
            long a = in.nextLong();
            long b = in.nextLong();
            long[] totalLengthWithSum = new long[BUBEN];
            long[] countWithSum = new long[BUBEN];
            countWithSum[0] = 1;
            totalLengthWithSum[0] = 2;
            ArrayList<Item> items = new ArrayList<>();
            items.add(new Item(BUBEN, totalLengthWithSum.clone(), countWithSum.clone()));
            for (int i = BUBEN - 1; i >= 2; --i) {
                if (!isPrime(i)) continue;
                int len = ("" + i).length();
                for (int j = BUBEN - 1 - i; j >= 0; --j)
                    if (countWithSum[j] > 0) {
                        totalLengthWithSum[i + j] += totalLengthWithSum[j] + (len + 2) * countWithSum[j];
                        countWithSum[i + j] += countWithSum[j];
                    }
                items.add(new Item(i, totalLengthWithSum.clone(), countWithSum.clone()));
            }
            Collections.reverse(items);
            long acc = 1;
            for (int i = 1; i < BUBEN; ++i) {
                long start = acc;
                acc += totalLengthWithSum[i];
                StringBuilder prefix = new StringBuilder();
                dump(items, Math.max(start, a) - start, Math.min(b, acc - 1) - start, i, prefix, 0, out);
            }
            out.println();
        }
 
        private void dump(ArrayList<Item> items, long left, long right, int sum, StringBuilder prefix, int atItem, PrintWriter out) {
            if (left > right) return;
            if (sum == 0) {
                String cur = "[" + prefix.toString();
                cur = cur.substring(0, cur.length() - 2) + "], ";
                if (left < 0 || right >= cur.length()) throw new RuntimeException();
                out.print(cur.substring((int) left, (int) right + 1));
                return;
            }
            int cnum = items.get(atItem).num;
            int savedSize = prefix.length();
            prefix.append(cnum);
            prefix.append(", ");
            Item it = items.get(atItem + 1);
            int nsum = sum - cnum;
            long withLeft = it.totalLengthWithSum[nsum] + prefix.length() * it.countWithSum[nsum];
            dump(items, left, Math.min(withLeft - 1, right), nsum, prefix, atItem + 1, out);
            prefix.delete(savedSize, prefix.length());
            dump(items, Math.max(0, left - withLeft), right - withLeft, sum, prefix, atItem + 1, out);
        }
 
        private boolean isPrime(int i) {
            for (int j = 2; j * j <= i; ++j) if (i % j == 0) return false;
            return true;
        }
 
        static class Item {
            int num;
            long[] totalLengthWithSum;
            long[] countWithSum;
 
            public Item(int num, long[] totalLengthWithSum, long[] countWithSum) {
                this.num = num;
                this.totalLengthWithSum = totalLengthWithSum;
                this.countWithSum = countWithSum;
            }
 
        }
 
    }
 
    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;
 
        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }
 
        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }
 
        public long nextLong() {
            return Long.parseLong(next());
        }
 
    }
}