import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

/**
 * @author Pavel Mavrin
 */
public class list_pm {

    private static final int MAX = 2100;
    private long[][] d;
    private long[][] ds;
    private long a, b;
    private int[] p;
    private int pp;

    private void solve() throws IOException {
        a = nextLong();
        b = nextLong();

        p = new int[MAX];
        pp = 0;
        for (int i = 2; i <= MAX; i++) {
            boolean ok = true;
            for (int j = 2; j * j <= i; j++) {
                if (i % j == 0) {
                    ok = false;
                    break;
                }
            }
            if (ok) {
                p[pp++] = i;
            }
        }
        d = new long[MAX][pp];
        ds = new long[MAX][pp];
        for (int i = 0; i < pp; i++)
            if (p[i] < MAX) {
                d[p[i]][i] = 1;
                ds[p[i]][i] = 4 + ("" + p[i]).length();
            }
        long s = 0;
        for (int i = 2; i < MAX; i++) {
            for (int j = pp - 1; j >= 0; j--) {
                if (j < pp - 1) {
                    d[i][j] += d[i][j + 1];
                    ds[i][j] += ds[i][j + 1];
                }
                if (j < pp - 1 && i > p[j]) {
                    d[i][j] += d[i - p[j]][j + 1];
                    ds[i][j] += ds[i - p[j]][j + 1] + d[i - p[j]][j + 1] * (2 + ("" + p[j]).length());
                }
            }
            s += ds[i][0];
//            System.out.println(i + " " + d[i][0] + " " + ds[i][0] + " " + s);
        }

        for (int i = 2; i < MAX; i++) {
            printSum(i, 0, "");
        }
        out.println();
    }

    long skipped = 0;
    long printed = 0;

    private void printSum(int s, int i, String pr) {
        if (s < 0 || s >= MAX || i < 0 || i >= pp || d[s][i] == 0 || printed == (b - a + 1)) {
            return;
        }
        long ss = ds[s][i] + pr.length() * d[s][i];
        if (skipped + ss < a) {
            skipped += ss;
//            System.out.println("skip " + s + " " + i + " " + pr + " " + ss);
        } else if (s == p[i]) {
            printString("[" + pr + p[i] + "], ");
        } else {
//            System.out.println(s + " " + i);
            printSum(s - p[i], i + 1, pr + p[i] + ", ");
            printSum(s, i + 1, pr);
        }
    }

    private void printString(String s) {
        for (int i = 0; i < s.length(); i++) {
            printChar(s.charAt(i));
        }
    }

    private void printChar(char c) {
        if (skipped + 1 < a) {
            skipped++;
        } else {
            if (printed < (b - a + 1)) {
                out.print(c);
                printed++;
            }
        }
    }

    private BufferedReader br;
    private PrintWriter out;
    private StringTokenizer st;

    String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    public static void main(String[] args) throws IOException {
        new list_pm().run();
    }

    private void run() throws IOException {
        br = new BufferedReader(new FileReader("list.in"));
        out = new PrintWriter("list.out");
        solve();
        out.close();
    }

}
