#include <cstdio>
#include <cassert>
#include <algorithm>
#include <vector>
#include <map>
#include <iostream>
#include <sstream>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define mp make_pair 
#define sz(a) (int)(a).size()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int PN = 10000;
const ll INF = 2e18;

map<pii, pll> m;
vector<int> a;
int pn, p[PN], len[PN];

pll F( int sum, int i ) {
	assert(i < PN);
	if (!sum) return pll(1, 2); // "[], " minus ", "
	if (p[i] > sum || sum < 0) return pll(0, 0);
	pii s(sum, i);
	if (!m.count(s)) {
		pll a = F(sum - p[i], i + 1);
		pll b = F(sum, i + 1);
		m[s] = pll(
			min(INF, a.first + b.first),
			min(INF, b.second + a.second + a.first * (len[i] + 2))
		);
		// m[s] = mpmin(INF, F(sum - p[i], i + 1) + F(sum, i + 1));
		// printf("calcF: %d, %d --> %lld, %lld\n", sum, i, m[s].first, m[s].second);
	} 
	return m[s]; 
}

bool first = 0;
ll l, r;

// [l, r)
void output( int sum, int i, int pref ) {
	assert(i < PN);
	pll f = F(sum, i);
	// printf("output: sum=%d, i=%d, pref=%d [l=%lld, r=%lld] f: count=%lld, sum=%lld\n",
	// 		sum, i, pref, l, r, f.first, f.second);
	ll num = f.second + f.first * pref;
	if (num <= l) {
		l -= num, r -= num;
		return;
	}
	if (!sum) {
		stringstream ss;
		ss << "[";
		for (int i = 0; i < sz(a) - 1; i++)
			ss << a[i] << ", ";
		ss << a.back() << "], ";
		for (char c : ss.str()) {
			if (l <= 0 && r > 0) {
				putchar(c);
			}
			l--, r--;
		}
		return;
	}
	if (r <= 0 || sum < 0 || p[i] > sum)
		return;
	a.push_back(p[i]);
	output(sum - p[i], i + 1, pref + (len[i] + 2));
	a.pop_back();
	output(sum, i + 1, pref);
}

int main() {
	assert(freopen("list.in", "r", stdin));
	assert(freopen("list.out", "w", stdout));

	for (int i = 2; i < PN; i++)
		if (!p[i]) {
			stringstream ss;
			ss << i;
			len[pn] = ss.str().length();
			p[pn++] = i;
			for (int j = i + i; j < PN; j += i)
				p[j] = 1;
		}

	// forn(i, 10) printf("p[%d] = %d, len = %d\n", i, p[i], len[i]);
	cin >> l >> r, l--; 
	for (int sum = 1; r > 0; sum++)
		output(sum, 0, 0);
	puts("");
}
