import java.io.*;
import java.util.*;

public class mole_bm {
	FastScanner in;
	PrintWriter out;

	int n, m;

	int[] bestLen;
	// -1 = left
	// 0 = stay here
	// +1 = right
	int[] bestDir;
	int[] food;
	int[] cntFreeUp;
	int[] cntFreeDown;

	void recalcBest(int v) {
		bestLen[v] = Integer.MAX_VALUE / 2;
		if (food[v] > 0) {
			bestLen[v] = 0;
			bestDir[v] = 0;
		}
		if (v * 2 + 1 < n) {
			int cost = bestLen[v * 2 + 1]
					+ (cntFreeDown[v * 2 + 1] > 0 ? -1 : 1);
			if (cost < bestLen[v]) {
				bestLen[v] = cost;
				bestDir[v] = -1;
			}
		}
		if (v * 2 + 2 < n) {
			int cost = bestLen[v * 2 + 2]
					+ (cntFreeDown[v * 2 + 2] > 0 ? -1 : 1);
			if (cost < bestLen[v]) {
				bestLen[v] = cost;
				bestDir[v] = 1;
			}
		}
	}

	int addPathUp(int from, int to) {
		int res = 0;
		while (from != to) {
			if (cntFreeUp[from] > 0) {
				cntFreeUp[from]--;
				res--;
			} else {
				cntFreeDown[from]++;
				res++;
			}
			from = (from - 1) / 2;
		}
		return res;
	}

	int goBestDown(int from) {
		int res = 0;
		while (true) {
			int dir = bestDir[from];
			if (dir == 0) {
				food[from]--;
				updateFromVertexUp(from);
				return res;
			}
			int next = from * 2 + (dir == -1 ? 1 : 2);
			if (cntFreeDown[next] > 0) {
				res--;
				cntFreeDown[next]--;
			} else {
				cntFreeUp[next]++;
				res++;
			}
			from = next;
		}
	}

	void updateFromVertexUp(int v) {
		while (true) {
			recalcBest(v);
			if (v == 0) {
				break;
			}
			v = (v - 1) / 2;
		}
	}

	void solve() {
		n = in.nextInt();
		m = in.nextInt();
		food = new int[n];
		for (int i = 0; i < n; i++) {
			food[i] = in.nextInt();
		}
		cntFreeUp = new int[n];
		cntFreeDown = new int[n];
		bestDir = new int[n];
		bestLen = new int[n];
		for (int i = n - 1; i >= 0; i--) {
			recalcBest(i);
		}
		long res = 0;
		for (int i = 0; i < m; i++) {
			int v = in.nextInt() - 1;
			int bestCost = bestLen[v];
			int curCost = 0;
			int bestLCA = v;
			for (int lca = v; lca > 0;) {
				curCost += cntFreeUp[lca] > 0 ? -1 : 1;
				lca = (lca - 1) / 2;
				int nowCost = curCost + bestLen[lca];
				if (nowCost < bestCost) {
					bestCost = nowCost;
					bestLCA = lca;
				}
			}
			res += addPathUp(v, bestLCA);
			res += goBestDown(bestLCA);
			updateFromVertexUp(v);
			out.print(res + " ");
		}
	}

	void run() {
		try {
			in = new FastScanner(new File("mole.in"));
			out = new PrintWriter(new File("mole.out"));

			solve();

			out.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	void runIO() {

		in = new FastScanner(System.in);
		out = new PrintWriter(System.out);

		solve();

		out.close();
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner(File f) {
			try {
				br = new BufferedReader(new FileReader(f));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		public FastScanner(InputStream f) {
			br = new BufferedReader(new InputStreamReader(f));
		}

		String next() {
			while (st == null || !st.hasMoreTokens()) {
				String s = null;
				try {
					s = br.readLine();
				} catch (IOException e) {
					e.printStackTrace();
				}
				if (s == null)
					return null;
				st = new StringTokenizer(s);
			}
			return st.nextToken();
		}

		boolean hasMoreTokens() {
			while (st == null || !st.hasMoreTokens()) {
				String s = null;
				try {
					s = br.readLine();
				} catch (IOException e) {
					e.printStackTrace();
				}
				if (s == null)
					return false;
				st = new StringTokenizer(s);
			}
			return true;
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}
	}

	public static void main(String[] args) {
		new mole_bm().run();
	}
}