import java.io.*;
import java.util.*;

public class mole_bm_wrong {
	FastScanner in;
	PrintWriter out;

	int n, m;

	int[] food;
	int[] cntFreeUp;
	int[] cntFreeDown;

	class Queue01 {
		int[] q;
		int n;

		public Queue01(int n) {
			q = new int[n * 2 + 1];
			this.n = n;
		}

		int qIt, qSz;

		void clear() {
			qIt = qSz = n;
		}

		int pollFirst() {
			return q[qIt++];
		}

		void pushFirst(int v) {
			qIt--;
			q[qIt] = v;
		}

		void pushLast(int v) {
			q[qSz++] = v;
		}
	}

	int[] prev;

	int addPath(int v) {
		int res = 0;
		while (prev[v] != -1) {
			int to = prev[v];
			if (v == (to - 1) / 2) {
				if (cntFreeUp[to] > 0) {
					cntFreeUp[to]--;
					res--;
				} else {
					cntFreeDown[to]++;
					res++;
				}
			} else {
				if (cntFreeDown[v] > 0) {
					cntFreeDown[v]--;
					res--;
				} else {
					cntFreeUp[v]++;
					res++;
				}
			}
			v = to;
		}
		return res;
	}

	void solve() {
		n = in.nextInt();
		m = in.nextInt();
		food = new int[n];
		for (int i = 0; i < n; i++) {
			food[i] = in.nextInt();
		}
		cntFreeUp = new int[n];
		cntFreeDown = new int[n];
		Queue01 queue = new Queue01(n);
		int[] d = new int[n];
		long res = 0;
		prev = new int[n];
		for (int i = 0; i < m; i++) {
			int v = in.nextInt() - 1;
			queue.clear();
			queue.pushFirst(v);
			d[v] = 0;
			prev[v] = -1;
			int best = Integer.MAX_VALUE;
			int bestTo = -1;
			while (queue.qIt < queue.qSz) {
				int u = queue.pollFirst();
				if (d[u] - 4 > best) {
					break;
				}
				if (food[u] > 0 && d[u] < best) {
					bestTo = u;
					best = d[u];
				}
				for (int add = 1; add <= 2; add++) {
					if (u * 2 + add < n && prev[u] != u * 2 + add) {
						if (cntFreeDown[u * 2 + add] > 0) {
							d[u * 2 + add] = d[u] - 1;
							queue.pushFirst(u * 2 + add);
						} else {
							d[u * 2 + add] = d[u] + 1;
							queue.pushLast(u * 2 + add);
						}
						prev[u * 2 + add] = u;
					}
				}
				if (u != 0 && prev[u] != (u - 1) / 2) {
					if (cntFreeUp[u] > 0) {
						d[(u - 1) / 2] = d[u] - 1;
						queue.pushFirst((u - 1) / 2);
					} else {
						d[(u - 1) / 2] = d[u] + 1;
						queue.pushLast((u - 1) / 2);
					}
					prev[(u - 1) / 2] = u;
				}
			}
			food[bestTo]--;
			int add = addPath(bestTo);
			res += add;
			if (add != d[bestTo]) {
				throw new AssertionError(d[bestTo] + " " + add);
			}
			out.print(res + " ");
		}
	}

	void run() {
		try {
			in = new FastScanner(new File("mole.in"));
			out = new PrintWriter(new File("mole.out"));

			solve();

			out.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	void runIO() {

		in = new FastScanner(System.in);
		out = new PrintWriter(System.out);

		solve();

		out.close();
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner(File f) {
			try {
				br = new BufferedReader(new FileReader(f));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		public FastScanner(InputStream f) {
			br = new BufferedReader(new InputStreamReader(f));
		}

		String next() {
			while (st == null || !st.hasMoreTokens()) {
				String s = null;
				try {
					s = br.readLine();
				} catch (IOException e) {
					e.printStackTrace();
				}
				if (s == null)
					return null;
				st = new StringTokenizer(s);
			}
			return st.nextToken();
		}

		boolean hasMoreTokens() {
			while (st == null || !st.hasMoreTokens()) {
				String s = null;
				try {
					s = br.readLine();
				} catch (IOException e) {
					e.printStackTrace();
				}
				if (s == null)
					return false;
				st = new StringTokenizer(s);
			}
			return true;
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}
	}

	public static void main(String[] args) {
		new mole_bm_wrong().run();
	}
}