#ifdef DBG1
  #define _GLIBCXX_DEBUG
#endif

#include <cstdio>
#include <cassert>
#include <cstring>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

#ifdef DBG1
    #define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
    #define eprintf(...)
#endif

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair <int, int> pii;

#define TASKNAME "mole"

const int inf = (int)1e9;

int n, *food, *edge, *d, *dd;

void recalc ( int i ) {
  // fprintf (stderr, "u=%d\n", i);
  dd[i] = -1;
  d[i] = inf;
  if (food[i] && 0 < d[i]) {
    dd[i] = 2;
    d[i] = 0;
  }
  for (int t = 0; t < 2; t++) {
    if (2 * i + t > n)
      continue;
    int r = d[2 * i + t] + ((edge[2 * i + t] >= 0) ? 1 : -1);
    // fprintf (stderr, "  -> %d (%d) with %d\n", t, 2 * i + t, r);
    if (r >= d[i])
      continue;
    d[i] = r;
    dd[i] = t;
  }
}

void eat ( int i ) {
  if (dd[i] == 2)
    food[i]--;
  else {
    assert (dd[i] == 0 || dd[i] == 1);
    eat (i * 2 + dd[i]);
    edge[i * 2 + dd[i]]++;
  }
  recalc (i);
}

int main() {
  freopen(TASKNAME ".in", "r", stdin);
  freopen(TASKNAME ".out", "w", stdout);

  int n, m;
  assert (scanf ("%d%d", &n, &m) == 2);
  int food[n + 1], edge[n + 1];
  for (int i = 0; i < n; i++) {
    assert (scanf ("%d", &food[i + 1]) == 1);
    edge[i + 1] = 0;
  }
  int d[n + 1], dd[n + 1];
  ::n = n, ::food = food, ::edge = edge;
  ::d = d, ::dd = dd;
  for (int i = n; i > 0; i--) {
    recalc (i);
  }
 
  int ans = 0;
  for (int i = 0; i < m; i++) {
    int x, res = inf, resk = -1, temp = 0;
    assert (scanf ("%d", &x) == 1);
    // for (int j = 0; j <= n; j++)
    //   fprintf (stderr, "d[j=%d] = %d,%d\n", j, d[j],dd[j]);
    for (int k = 0; x / (1 << k) > 0; k++) {
      int y = x / (1 << k);
      if (res > temp + d[y]) {
        res = temp + d[y];
        resk = k;
        // fprintf (stderr, "k=%d, res = %d\n", k, res);
      }
      temp += edge[y] > 0 ? -1 : 1;
    }
    assert (res < inf / 2);
    for (int i = 0; i < resk; i++) {
      int y = x / (1 << i);
      edge[y]--;
      recalc (y);
    }
    // fprintf (stderr, "x=%d -> %d\n", x, x / (1 << resk));
    eat (x / (1 << resk));
    for (int y = x / (1 << resk); y > 0; y /= 2) {
      recalc (y);
    }
    ans += res;
    // fprintf (stderr, "res = %d\n", res);
    printf ("%d%c", ans, "\n "[i < m - 1]);
  }

  return 0;
}

