#include <cstdio>
#include <vector>
#include <cassert>

using namespace std;

const int MAXN = 100100;

const int INF = 1 << 30;

int flow[MAXN];
int food[MAXN];
int ufood[MAXN];
int best[MAXN];
int n, m;

int get_cost_down(int x) {
  if (flow[x] <= 0) return 1;
  return -1;
}

int get_cost_up(int x) {
  if (flow[x] >= 0) return 1;
  return -1;
}

void recalc(int x) {
  if (ufood[x] < food[x]) {
    best[x] = 0;
  } else {
    best[x] = INF;
  }
  if (2*x  <= n) {
    best[x] = min(best[x], best[2 * x] + get_cost_down(2*x));
  } 
  if (2*x + 1 <= n) {
    best[x] = min(best[x], best[2 * x + 1] + get_cost_down(2*x + 1));
  }
}

int main() {
  assert(freopen("mole.in", "r", stdin));
  assert(freopen("mole.out", "w", stdout));

  assert(scanf("%d%d", &n, &m) == 2);

  for (int i = 1; i <= n; i++) {
    assert(scanf("%d", &food[i]) == 1);
    ufood[i] = 0;
  }
  for (int i = n; i >= 1; i--) {
    recalc(i);
  }

  int ans = 0;

  for (int j = 0; j < m; j++) {
    
    //for (int k = 1; k <= n; k++) {
    //  fprintf(stderr, "%d ", best[k]);
    //}
    //fprintf(stderr, "\n");

    int x;
    assert(scanf("%d", &x) == 1);

    int res = INF;
    int bestv = -1;
    int cur = 0;
    
    int y = x;
    while (y) {
      if (res > best[y] + cur) {
        res = best[y] + cur;
        bestv = y;
      }
      cur += get_cost_up(y);
      y /= 2;
    }
    
    int oldx = x;

    vector<int> path;

    while (x > bestv) {
      recalc(x);
      ans += get_cost_up(x);
      path.push_back(x);
      x /= 2;
    }
    
    assert(res < INF / 2);


    while (true) {
      assert(x <= n);
      if (best[x] == 0 && ufood[x] < food[x]) {
        ufood[x]++;
        break;
      }
      if (best[x] == best[2 * x] + get_cost_down(2 * x)) {
        ans += get_cost_down(2 * x);
        x = 2 * x;
      } else {
        assert(best[x] == best[2*x + 1] + get_cost_down(2 * x + 1));
        ans += get_cost_down(2 * x + 1);
        x = 2 * x + 1;
      }
      flow[x]--;
    }

    for (int i : path) flow[i]++;

    while (oldx) {
      recalc(oldx);
      oldx /= 2;
    }
    while (x) {
      recalc(x);
      x /= 2;
    }


    printf("%d%c", ans, " \n"[j == m - 1]);
  }


  return 0;
}
